
-- script to test the AI library

v.ai = 0
v.q1 = 0
v.q2 = 0
v.hand1 = 0
v.hand2 = 0

v.shotT = 0
v.inCombat = false
v.moving = false

local function makeq(s, a)
    local q = createQuad("softglow-add", 13)
    quad_setBlendType(q, BLEND_ADD)
    quad_color(q,  0.95, 0.45, 0.08)
    if not s then s = 0.5 end
    if not a then a = 0 end
    quad_scale(q, s, s)
    quad_alpha(q, a)
    --quad_alphaMod(q, 0.6)
    return q
end

local function attack(me, who)
    if v.shotT <= 0 then
        v.shotT = 1
        local s = createShot("energyblast", me, who)
        --local q = makeq(3, 1)
        --obj_addChild(s, q, true)
        --obj_setLayer(s, 30)
    end
end

local function updateAnim(me)
    if v.moving then
        entity_animate(me, "swim", -1)
    else
        if v.inCombat then
            entity_animate(me, "idleenergy", -1)
        else
            entity_animate(me, "idle", -1)
        end
    end
end

local function glowAlpha(a)
    quad_alpha(v.q1, a, 1)
    quad_alpha(v.q2, a, 1)
end

local function toggleCombat(me, on)
    if on and not v.inCombat then
        v.inCombat = true
        glowAlpha(1)
        updateAnim(me)
    elseif not on and v.inCombat then
       v.inCombat = false
        glowAlpha(0)
        updateAnim(me)
    end
end

function init(me)

    setupBasicEntity(me, 
    "",								-- texture
    32,								-- health
    1,								-- manaballamount
    1,								-- exp
    1,								-- money
    28,								-- collideRadius (only used if hit entities is on)
    STATE_IDLE,						-- initState
    64,								-- sprite width	
    64,								-- sprite height
    1,								-- particle "explosion" type, maps to particleEffects.txt -1 = none
    1,								-- 0/1 hit other entities off/on (uses collideRadius)
    -1							-- updateCull -1: disabled, default: 4000
    )

    entity_initSkeletal(me, "krotite")
    entity_setDeathParticleEffect(me, "TinyGreenExplode")

    entity_scale(me, 0.5, 0.5)

    --local bGlow = entity_getBoneByName(me, "Glow")
    --local bNote = entity_getBoneByName(me, "Note")
    --bone_setBlendType(bGlow, BLEND_ADD)
    --bone_setBlendType(bNote, BLEND_ADD)
    --bone_alpha(bGlow, 0)
    --bone_alpha(bNote, 0)
    esetv(me, EV_LOOKAT, 1)

    --entity_setAllDamageTargets(me, false)


    entity_setEntityType(me, ET_NEUTRAL)

    --entity_setSpiritFreeze(me, false)

    entity_setBeautyFlip(me, false)


    
    entity_setMaxSpeed(me, 300)
    
    
    v.hand1 = entity_getBoneByIdx(me, 14)
    v.hand2 = entity_getBoneByIdx(me, 15)
    --bone_alpha(v.hand1, 0.001)
    --bone_alpha(v.hand2, 0.001)
    v.q1 = makeq()
    v.q2 = makeq()
    
    
    v.ai = ai_create(me, AI_FOLLOWER, AI_AGGRESSIVE)
    v.ai.setDamageType = DT_AVATAR_ENERGYBLAST
    v.ai:setCallback("moveStart", function(me) v.moving = true updateAnim(me) end)
    v.ai:setCallback("moveStop", function(me) v.moving = false updateAnim(me) end)
    v.ai:setCallback("combatStart", function(me)  v.ai:disable(AI_FOLLOWER) toggleCombat(me, true)  end)
    v.ai:setCallback("combatStop",  function(me)  v.ai:enable(AI_FOLLOWER)  toggleCombat(me, false) end)
    v.ai:setCallback("attack", attack)
end

function postInit(me)
    entity_idle(me)
    
    v.ai:addFriend(getNaija())
end

function shiftWorlds(me, old, new)
end

function song(me, song)
end

function update(me, dt)
    v.ai:update(dt)
    
    if v.shotT > 0 then
        v.shotT = v.shotT - dt
    end
    
    toggleCombat(me, isForm(FORM_ENERGY))
    
    quad_setPosition(v.q1, bone_getWorldPosition(v.hand1))
    quad_setPosition(v.q2, bone_getWorldPosition(v.hand2))
end

function damage(me, attacker, bone, damageType, dmg)
    v.ai:damage(attacker, bone, damageType, dmg)
	return false
end

function enterState(me, state)
end

function exitState(me)
end

function hitSurface(me)
end

function msg(me, msg, val)
end

function songNote(me, note)
end

function songNoteDone(me, note, len)
end

function entityDied(me, e)
    v.ai:entityDied(e)
end
