
-- helper entity that measures a current speed

dofile("scripts/inc_util.lua")

local MEASURE_DELAY = 0.25

v.oldx = 0
v.oldy = 0
v.t = MEASURE_DELAY

function init(me)
    setupEntity(me)
    entity_setEntityType(me, ET_NEUTRAL)
    entity_setTexture(me, "missingimage")
    
    if getFlag(FLAG_DBG_VISUALS) == 0 then
        entity_alpha(me, 0.001)
    end
    
    esetv(me, EV_LOOKAT, false)
    entity_setAllDamageTargets(me, false)
    entity_setUpdateCull(me, -1)
    entity_setCanLeaveWater(me, false)
    entity_setInvincible(me, true)
    entity_setMaxSpeed(me, 9999)
    
    v.oldx, v.oldy = entity_getPosition(me)
    entity_addVel(me, 0.001, 0.001) -- necessary to trigger current movement
end



function postInit(me)
end

local function handleDistance(dx, dy)
    --debugLog("dx: " .. dx .. ", dy: " .. dy)
    
    -- TODO: send these data somewhere
    -- FIXME: this entity is unused so far.
end

function update(me, dt)
    entity_updateCurrents(me, dt)
    entity_updateMovement(me, dt)
    
    if v.t >= 0 then
        v.t = v.t - dt
        if v.t <= 0 then
            v.t = v.t + MEASURE_DELAY
            local x, y = entity_getPosition(me)
            local dx, dy = v.makeVector(v.oldx, v.oldy, x, y)
            handleDistance(dx / MEASURE_DELAY, dy / MEASURE_DELAY) -- scale to 1
            entity_setPosition(me, v.oldx, v.oldy)
        end
    end
    
end

function enterState(me)
end

function exitState(me)
end

function msg(me, msg)
end

function damage(me, attacker, bone, damageType, dmg)
	return false
end

function animationKey(me, key)
end

function hitSurface(me)
end

function songNote(me, note)
end

function songNoteDone(me, note)
end

function song(me, song)
end

function activate(me)
end

