

v.area = 0
v.mia = 0

v.sleeptimer = 6 -- time naija must remain sleeping to trigger this cutscene


v.init = function(me)
end

v.cutscene = function(force, dt)
    
    if not (force or v.isDebug() or isStory(STORY_NAIJA_MIAJAIL)) then
        return false
    end
    
    --if force then
    --    v.sleeptimer = 0
    --end
    
    local n = getNaija()
    
    if entity_isState(n, STATE_SLEEP) and not isStreamingVoice() then
        v.sleeptimer = v.sleeptimer - dt
        debugLog("sleep remain: " .. v.sleeptimer)
    end
    if v.sleeptimer > 0 then
        return
    end
    
    debugLog("good morning scene")
    
    local miastart = getNode("miastart")
    local mx, my = node_getPosition(miastart)
    
    local mia = getEntity("mia")
    if mia ~= 0 then
        entity_setPosition(mia, mx, my)
    else
        mia = createEntity("mia", "", mx, my)
    end
    
    
    spawnParticleEffect("spiritbeacon", mx, my)
    playSfx("spirit-return")
    watch(0.2)
    entity_alpha(mia, 1)
    
    setFlag(FLAG_BREAK_SLEEP, 0) -- allow waking up on click
    
    setCutscene(1, 1)
    
    voice("miajailgoodmorning")
    
    -- wait a bit while naija still sleeps, if she gets up earlier, even better
    local waittime = 8
    while waittime > 0 and entity_isState(n, STATE_SLEEP) do
        watch(FRAME_TIME)
        waittime = waittime - FRAME_TIME
        debugLog("waittime: " .. waittime)
    end
    watch(0.5)
    -- if the lazy bum didn't get up, start shooting until she wakes up
    setInvincibleOnNested(false)
    while entity_isState(n, STATE_SLEEP) do
        entity_msg(mia, "target")
        entity_msg(mia, "naija")
        entity_msg(mia, "shoot")
        watch(1)
    end
    setInvincibleOnNested(true)
    
    watch(0.3)
    if not entity_isfh(n) then
        entity_fh(n)
    end
    entity_swimToPosition(mia, entity_x(mia) - 10, entity_y(n))
    watch(0.3)
    emote(EMOTE_NAIJAUGH)
    setNaijaHeadTexture("shock")
    
    voice("miajailgoodmorning2")
    watch(0.7)
    setNaijaHeadTexture("")
    
    --watch(4)
    --entity_idle(n)
    -- TODO: "yawn" animation ??
    watchForVoice()
    entity_animate(n, "pushback", 2)
    --entity_addVel(n, -100, 0) -- to left -- does not work in watch(), grrr
    entity_interpolateTo(n, entity_x(n) - 100, entity_y(n), 1.5)
    watch(0.7)
    
    setCutscene(0)
    
    local nx, ny = entity_getPosition(n)
    nx = nx + 40
    entity_swimToPosition(mia, nx, ny)
    entity_watchForPath(mia)
    
    mx, my = entity_getPosition(mia)
    spawnParticleEffect("spiritbeacon", mx, my)
    spawnParticleEffect("spiritbeacon", entity_getPosition(n))
    playSfx("spirit-return")
    watch(FRAME_TIME)
    playSfx("spirit-return")
    watch(0.2)
    entity_alpha(mia, 0)
    entity_alpha(n, 0)
    
    fadeOut(3)
    watch(3)
    
    
    if v.isDebug() then
        fadeIn(1)
        entity_alpha(n, 1)
        entity_alpha(mia, 1)
    else
        v.doTransitionTo("naijamiajailout")
    end

    v.sleeptimer = 6 -- for debug
    return
end
