
v.delay = 8.4 -- must match delay for animation in init below

v.area = 0
v.mia = 0
v.noscene = 0


v.init = function(me)
    v.noscene = node_getNearestNode(me, "noscene")
    v.area = node_getNearestNode(me, "naijacrystal")
    loadSound("mia-appear")
    loadSound("mia-scream")
    
    local n = getNaija()
    
    if getStringFlag("TEMP_trapsavepoint") ~= "" then
        v.noinput = true
        entity_setState(n, 12345) -- block anim override
        local a = entity_animate(n, "smashed", 0, 0, -1) -- instant anim
        v.delay = a + 0.2
        v.pushTQ(a, function() v.noinput = false enableInput() entity_idle(n)  end)
        entity_fh(n) -- face right
    else
        v.delay = 4
    end
        
        
end

local function watchForCamToEntity(e, w)
    cam_toEntity(e)
    if w then
        watch(w)
    end
end


local function chaseMia()

    local mx, my = node_getPosition(getNode("miastart"))
    
    spawnParticleEffect("spiritbeacon", mx, my)
    playSfx("spirit-return")

    if v.mia == 0 then
        v.mia = createEntity("mia", "", mx, my)
    else
        entity_warpToNode(getNode("miastart")) -- for debugging
    end
    
    local ld = 0.3
    
    watchForCamToEntity(v.mia, ld)
    
    emote(EMOTE_NAIJAUGH)
    
    local n = getNaija()
    local mpos = getNode("miapos1")
    local npos = getNode("naijapos1")
    entity_flipToNode(v.mia, mpos)
    entity_swimToNode(v.mia, mpos)
    entity_watchForPath(v.mia)
    entity_fh(v.mia)
    
    watchForCamToEntity(n, ld)
    
    setCanChangeForm(true) -- it was probably disabled in miajail exit cutscene
    changeForm(FORM_ENERGY)
    entity_flipToNode(n, npos)
    entity_swimToNode(n, npos)
    entity_watchForPath(n)
    
    watch(0.3)

    local barrier = getNode("powerlinesvspecial")
    node_activate(barrier) -- turn on
    playSfx("defense")
    
    setMusicToPlay("inevitable")
    playMusic("inevitable")
    
    watch(1)
    entity_fh(n)
    watch(0.3)
    emote(EMOTE_NAIJAUGH)
    watch(0.5)
    entity_fh(n)
    watch(0.5)
    
    
    
    spawnParticleEffect("spiritbeacon", entity_getPosition(v.mia))
    entity_playSfx(v.mia, "spirit-beacon")
    entity_alpha(v.mia, 0)
    entity_warpToNode(v.mia, getNode("miapos2"))
    
    watch(0.4)
    watchForCamToEntity(v.mia, ld)
    
    spawnParticleEffect("spiritbeacon", entity_getPosition(v.mia))
    entity_playSfx(v.mia, "spirit-return")
    entity_alpha(v.mia, 1)
    entity_fh(v.mia)
    
    watch(2)
    
    watchForCamToEntity(n, ld)
    
    setCameraLerpDelay(0)
    
    voice("miatrapsnaija")
    
    
    
    
end

v.cutscene = function(force)
    local n = getNaija()
    
    --[[if node_isEntityIn(v.noscene, n) then
        if not force then
            return nil
        end
    end]]
    
    if not (v.isDebug() or isStory(STORY_NAIJA_MIAJAIL)) then
        return false
    end

    debugLog("miaTrapsNaija")
    
    v.noinput = false
    enableInput()
    
    
    setSceneColor(0.15, 0.3, 0.5, 2)
    --watch(0.1)
    --entity_animate(n, "idle")
    
    --entity_flipToNode(n, me)
    --entity_moveToNode(n, me, 5)
    --entity_rotate(n, 0, 0.4)
    
    --[[
    watch(2)
    playSfx("mia-appear")
    watch(2)
    playSfx("mia-scream")
    watch(1)
    ]]
    
    --overrideZoom(0.4)
    watch(0.5)
    chaseMia()
    
    --overrideZoom(0)
    
    
    --setSceneColor(1,1,1,1)
    --enableInput()
    
    v.cutscene = v.otherStuff -- from now on, prevent naija from dying until she's in the crystal
    return nil
end

function v.otherStuff(force)
    local n = getNaija()
    if entity_getHealthPerc(n) < 0.3 then
        entity_heal(n, 99)
        if not isForm(FORM_SPIRIT) then
            changeForm(FORM_SPIRIT)
        end
    end
    
    if getFlag(FLAG_NAIJA_IN_CRYSTAL) ~= 0 then
        return true
    end

end