-- Copyright (C) 2007, 2010 - Bit-Blot
--
-- This file is part of Aquaria.
--
-- Aquaria is free software; you can redistribute it and/or
-- modify it under the terms of the GNU General Public License
-- as published by the Free Software Foundation; either version 2
-- of the License, or (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
--
-- See the GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

if not v then v = {} end

dofile("scripts/template_bombbreakable.lua")

local P_NONE = 0
local P_POWER = 1
local P_CURE = 2

v.power = 0
v.ptimer = 0
v.fxtimer = 0

v.dt = 0

function init(me)
	loadSound("licage-shatter")
	v.breakableInit(me, "green-crystal", 64, 2, 3, "licage-shatter", true, 20)
	entity_scale(me, 0.8, 0.8)
	
	entity_setAllDamageTargets(me, false)
end

function update(me, dt)
	v.breakableUpdate(me, dt)
	
	if v.power > P_NONE then
		if v.ptimer < dt then
			v.doPower(me, P_NONE)
		else
			v.pfx(me, dt) -- special powertype fx
			v.ptimer = v.ptimer - dt
		end
	end
	
	--[[if v.dt < dt then
		v.dt = 1
		debugLog("dmg now -->")
		entity_damage(me, me, 0.3)
	else
		v.dt = v.dt - dt
	end--]]
end

function song(me, num)
	if num == 100 then
		debugLog("green crystal power")
		v.doPower(me, P_POWER)
	elseif num == 101 then
		debugLog("green crystal cure")
		v.doPower(me, P_CURE)
	end
end

function msg(me, s, x)
	if s == "click" then
		v.infusePower(me)
	end
end

function v.pfx(me, dt)
	if v.fxtimer < dt then
		v.fxtimer = 0.4
		if v.power == P_POWER then
			spawnParticleEffect("energyorbcharge", entity_x(me), entity_y(me))
		elseif v.power == P_CURE then
			spawnParticleEffect("creatorblasthit", entity_x(me), entity_y(me))
		end
	else
		v.fxtimer = v.fxtimer - dt
	end
end
		

function v.doPower(me, p)
	v.power = p
	if p == P_NONE then
		v.ptimer = 0
	else
		v.ptimer = 10
	end
	-- TODO: fx ?
end

function v.infusePower(me)
	local n = getNaija()
	debugLog(string.format("infuse power: %d", v.power))
end
	
-- TODO: make node determine power, and send this as message to the entity
-- required for prope3r cursor activation!!!



