
if not v then v = {} end

dofile("scripts/inc_util.lua")
dofile("scripts/inc_flagfunc.lua")
dofile("scripts/template_bombbreakable.lua")

local E_OFF = 0
local E_ACTIVATE = 1
local E_APPLY = 2

local ACTIVETIME = 9999 -- FIXME!

local STATE_DISABLED = 1000

v.eff = 0
v.ptimer = 0
v.fxtimer = 0
v.light = 0

v.dt = 0


function v.applyPowerCE(me, on)
    if on == E_APPLY then
        debugLog("-power apply")
        v.applyCrystalEffect(CE_POWER)
    elseif on == E_ACTIVATE then
        debugLog("-power activate")
        entity_setActivationType(me, AT_CLICK)
    else
        debugLog("-power off")
        entity_setActivationType(me, AT_NONE)
    end
end

function v.applyCureCE(me, on)
    if on == E_APPLY then
        debugLog("-cure apply")
        v.applyCrystalEffect(CE_CURE)
    elseif on == E_ACTIVATE then
        debugLog("-cure activate")
        entity_setActivationType(me, AT_CLICK)
    else
        debugLog("-cure off")
        entity_setActivationType(me, AT_NONE)
    end
end

function v.applyEchoCE(me, on)

    if on == E_APPLY then
        debugLog("-echo apply")
        
    elseif on == E_ACTIVATE then
        debugLog("-echo activate")
        entity_setDamageTarget(me, DT_AVATAR_ENERGYBLAST, true)
        entity_setDamageTarget(me, DT_AVATAR_SHOCK, true)
        entity_setActivationType(me, AT_NONE)
    else
        debugLog("-echo off")
        entity_setDamageTarget(me, DT_AVATAR_ENERGYBLAST, false)
        entity_setDamageTarget(me, DT_AVATAR_SHOCK, false)	
        --entity_setActivationType(me, AT_CLICK)
    end
end


function init(me)
	loadSound("licage-shatter")
	v.breakableInit(me, "green-crystal", 64, 2, 3, "licage-shatter", true, 20)
	entity_scale(me, 0.8, 0.8)
    --entity_setEntityLayer(me, -2) -- done in node_greencrystal, conditionally
    v.light = createQuad("greenglow", 13)
    quad_scale(v.light, 8, 8)
    local x, y = entity_getPosition(me)
    quad_setPosition(v.light, x, y)
    quad_alpha(v.light, 0.2)
    quad_alpha(v.light, 0.4, 1.2, -1, 1)
	
	entity_setAllDamageTargets(me, false)
    --entity_setActivation(me, AT_CLICK, 70) -- does not work ?!
    entity_setActivationType(me, AT_NONE)
    entity_setCollideRadius(me, 85)
    
    v.effdata = {}
    dofile("scripts/inc_ce_table.lua")
end

-- called when a song activates the crystal and it starts sparkling and reacting to clicks
local function doActivateEffect(me, p)
    v.fxtimer = 0
    local ce = v.effdata[v.eff]
    -- turn off if still activated
    if v.ptimer > 0 and ce then
        ce.func(me, E_OFF)
    end
    
	if p == CE_NONE then
		v.ptimer = 0
	else
		v.ptimer = ACTIVETIME
	end
    v.eff = p
    
    ce = v.effdata[v.eff]
    if ce  then
        ce.func(me, E_ACTIVATE)
    end
    
	-- TODO: initial fx ?
end

-- called when right-clicking on the crystal
local function doApplyEffect(me, p)
    local ce = v.effdata[v.eff]
    if not ce then
    
        --- TEMP ----- FIXME ----  !!!
        playNoEffect()
        --if chance(50) then
            setControlHint("This is the Song of Echo!", 0, 0, 0, 4,"",102)
        --else
        --    setControlHint("This is how to summon bombs!", 0, 0, 0, 4,"",150)
        --end
        
        
        return
    end
    
    spawnParticleEffect("greencrystalzap", entity_x(v.n), entity_y(v.n))
    
    if ce.pe then
        local x, y = entity_getPosition(me)
        spawnParticleEffect(ce.pe, x, y)
    end
    
    ce.func(me, E_APPLY)
end


function update(me, dt)
	v.breakableUpdate(me, dt)
	
	if v.eff > CE_NONE then
		if v.ptimer < dt then
			doActivateEffect(me, CE_NONE) -- turn off
		else
			v.ptimer = v.ptimer - dt
		end
        
        if v.fxtimer < dt then
            local eff = v.effdata[v.eff]
            if eff then
                spawnParticleEffect(eff.fx, entity_x(me), entity_y(me)) -- special powertype fx
                v.fxtimer = eff.fxt
            else
                v.fxtimer = 0.2 -- delay recheck
            end
        else
            v.fxtimer = v.fxtimer - dt
        end
	end
    
    
    -- DEBUG: only req. for editing
    local x, y = entity_getPosition(me)
    quad_setPosition(v.light, x, y)
    
end

function song(me, num)
	if num == 100 then
		debugLog("green crystal power")
		doActivateEffect(me, CE_POWER)
	elseif num == 101 then
		debugLog("green crystal cure")
		doActivateEffect(me, CE_CURE)
	elseif  num == 102 then
		debugLog("green crystal echo")
		doActivateEffect(me, CE_ECHO)
	end
end

function activate(me)
    if v.isNaija() then
        doApplyEffect(me)
    end
end

function v.onDeath(me)
    --quad_alpha(v.light, quad_getAlpha(v.light)) -- stop interpolation ping-pong
    quad_delete(v.light) -- TODO: fade out does not seem to work that it looks well
end

function v.onDamage(me, attacker, damageType, dmg)
    if not entity_isDamageTarget(me, damageType) then
        return
    end
    
    if v.eff == CE_ECHO then
        local n = getNaija()
        local dx, dy = vector_normalize(v.entity_getVectorToCursor(me))
        
        local st = nil
        local targ = nil
        if attacker == n then
            st = "energyblast2"
            -- HMM: right now this targets naija as well, but the shots are just circling around her,
            -- turning her into a dangerous missile for a short time. I think i'll leave this in, its cool. :P
            targ = v.getNearestEntityToCursor("!greencrystal", 500, ET_ENEMY, DT_AVATAR_ENERGYBLAST)
            if targ == 0 then
                targ = v.getNearestEntityToCursor("!greencrystal", nil, nil, DT_AVATAR_ENERGYBLAST)
            end
            if targ ~= 0 then
                debugLog("crystal echo target: " .. entity_getName(targ))
            end
            
        elseif entity_isName(attacker, "mia") then
            st = "miablast1" -- FIXME
            targ = n
        end
        
        local angles = { -45, -22, 22, 45 }
	    
        if st then
            for _,a in pairs(angles) do
                local s = createShot(st, me, targ)
                local sx, sy = v.vector_rotateDeg(dx, dy, a)
                shot_setAimVector(s, sx, sy)
            end
        end
    end
end

function msg(me, msg, x)
    if msg == "off" then
        entity_setState(me, STATE_DISABLED)
        v.disableEntity(me)
    end
end
