
-- misc functions that mostly have to do with flags,
-- are not worthy/generic enough to go into inc_util.lua,
-- and are too seldomly used to go into inc_flags.lua.

if not v then v = {} end

dofile("scripts/inc_flags.lua")

-- madness rating
-- just to finetune some scenes
MAD_FINE = 0
MAD_SLIGHTLY = 1
MAD_LIMIT = 2 -- as soon as this is the current rating, there is no way back
MAD_MAX = 3

function v.setNaijaMadness(f)
    v.setNumFlag("Naija_madness", f)
    debugLog("Naija madness now: " .. f)
end

function v.getNaijaMadness()
    return v.getNumFlag("Naija_madness")
end

-- TODO: eh... have to get a plan what to do with the ratings
function v.getNaijaMadnessRating()
    local m = v.getNaijaMadness()
    if m < 2000 then return MAD_FINE end
    if m < 2500 then return MAD_SLIGHTLY end
    if m >= 2500 then
        if m > 4000 then return MAD_MAX end
        
        return MAD_LIMIT
    end
end


-- return value between 0 (weak/normal) to 1 (insanely powerful)
    --[[ calculation rules:
        - madness can add up to 0.8, with 5000 beeing the cap [FIXME: what should the sane max. be ?]
        - if CE_POWER is active, add 0.42 -- TODO: it is supposed to unlock the hard ("explosion") energy charge 2 after a little bit of training with this. adjust values.
        - existing crystals add up to 0.5, but only after naija learned to use them REMOTELY ( -> flag FLAG_CAN_USE_CRYSTAL_POWER ~= 0)
        
        -- TODO: dampen power a LOT, the more crystals are destroyed. sort of, affecting all madness below 5000. If its over 5000, calculate with (current-5000) as usual
        
        - power is capped between [0 .. 1]
    ]]--
function v.calcNaijaPower(dbgPrint)

    --if true then
    --    return 1
    --end
    
    local mad = v.getNaijaMadness()
    if mad > 5000 then
        mad = 5000
    end
    
    local madpower = (mad / 5000.0) * 0.8
    
    local cpower = 0
    
    if getFlag(FLAG_CAN_USE_CRYSTAL_POWER) ~= 0 then
        local cdest = getFlag(FLAG_GREENCRYSTALS_DESTROYED)
        local cleft = MOD_MAX_GREENCRYSTALS - cdest
        if cleft < 0 then
            centerText("FIXME: MOD_MAX_GREENCRYSTALS too low")
            cleft = 0
        end
        cpower = (cleft / MOD_MAX_GREENCRYSTALS) --* 0.5 -- FIXME: for test its 1.0 !!
    end
    
    local cepower = 0
    if v.getNumFlag("Naija_ce") ~= CE_NONE then
        cepower = 0.42
    end
    
    -- TODO: more sources?
    
    local finalpower = madpower + cpower + cepower
    
    if finalpower > 1 then
        finalpower = 1
    elseif finalpower < 0.02 then
        finalpower = 0
    end
    
    --debugLog("Naija power: " .. finalpower)
    if dbgPrint then
        v.edbg(getNaija(), string.format("Naija power: %.3f + %.5f = %.5f", cpower, madpower, finalpower), 6)
    end
    return finalpower
    
end

function v.applyCrystalEffect(eff)
    setFlag(FLAG_ACTIVE_CRYSTAL_POWER, eff) -- logichelp_entitydeath.lua looks for this
end

-- in logichelp_entitydeath.lua: used to decide if killing an entity should have an effect
function v.entity_countsAsEntity(e)
    -- TODO: add stuff here later. could use esetv() with an unused flag (there's at least 2)
    
    -- NOT:
    -- bombrock*
    -- krill, krilleggs
    
    return entity_getEntityType(e) == ET_ENEMY
end
