
-- this file should not be included in normal scripts

local orig = 0

-- pre-decl used functions in v - not all callers may have the necessary includes!
-- (so it would fail to find them in v)
local isDebug = 0
local isNaija = 0


local function emote_new(em)
    debugLog("emote_new(" .. em .. ")")
    if isNaija() then
        orig.emote(em)
    else
        -- TODO: add some emotes for the other playable characters?
        debugLog("GLOBALOVERRIDE FIXME: emote() not Naija")
    end
end

-- FIXME: for debugging and GREPing - remove later
local function debugLog_new(s)
    orig.debugLog("[] " .. s)
    --if isDebug() then
    --    playSfx("swimkick", 1.2, 0.4)
    --end
end

local function entity_delete_new(e, ...)
    entity_markDeleted(e) -- FIXME: not 100% correct if timed
    return orig.entity_delete(e, ...)
end

local function createEntity_new(...)
    local e = orig.createEntity(...)
    entity_markExisting(e)
    return e
end

local function setupEntity_new(...)
    local e = orig.createEntity(...)
    entity_markExisting(e)
    return e
end

local function setupBasicEntity_new(...)
    local e = orig.setupBasicEntity(...)
    entity_markExisting(e)
    return e
end

local function installGlobalOverrides()
    --if rawget(_G, "__overrides_done") then
    --    return
    --end
    
    debugLog("installGlobalOverrides()")
    
    dofile("scripts/inc_flags.lua")
    
    isDebug = v.isDebug
    isNaija = v.isNaija
    
    dofile("scripts/inc_globalhacks.lua")
    
    orig = v.oldglobals()
    
    
    v.overrideGlobal("emote", emote_new)
    v.overrideGlobal("debugLog", debugLog_new)
    
    -- entity memory protection
    --v.overrideGlobal("entity_delete", entity_delete_new)
    --v.overrideGlobal("createEntity", createEntity_new)
    --v.overrideGlobal("setupEntity", setupEntity_new)
    --v.overrideGlobal("setupBasicEntity", setupBasicEntity_new)
    -- FIXME: this crashes
    
    debugLog("... global overrides installed")
    
    rawset(_G, "__overrides_done", true)
end


installGlobalOverrides()
