
if not v then v = {} end

v._srcnode = false

-- fallback
local function spawnAndWarp(to_node, entname)
    local e = createEntity(entname)
    entity_setPosition(e, node_x(to_node), node_y(to_node))
    debugLog("prespawnwarp: fallback spawn " .. entname)
    return e
end

-- fetch prespawned entity instead of creating
-- causes no stuttering when a few complicated entities are created at once (like mutantnaija),
-- because they were already created while the map was blacked out
function v.fetchEntity(to_node, entname)
    if not v._srcnode then
        v._srcnode = node_getNearestNode(to_node, "prespawn")
        -- if its set to 0, no attempt will be made to find it later on, which is ok.
    end
    
    local src = v._srcnode
        
    if src == 0 then
        return spawnAndWarp(to_node, entname)
    end
    
    local e = node_getNearestEntity(src, entname)
    if e == 0 or not node_isEntityIn(src, e) then
        return spawnAndWarp(to_node, entname)
    end
    
    entity_setPosition(e, node_x(to_node), node_y(to_node))
    return e
end
