-- Copyright (C) 2007, 2010 - Bit-Blot
--
-- This file is part of Aquaria.
--
-- Aquaria is free software; you can redistribute it and/or
-- modify it under the terms of the GNU General Public License
-- as published by the Free Software Foundation; either version 2
-- of the License, or (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
--
-- See the GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

if not v then v = {} end
if not AQUARIA_VERSION then dofile("scripts/entities/entityinclude.lua") end

dofile("scripts/inc_util.lua")

local STATE_WORSHIP = 1000
local STATE_WORSHIP2 = 1001
local STATE_WSHOCKED = 1002

v.n = 0
v.poi = 0
v.gopoi = 0
v.idletimer = 0
v.gox = 0
v.goy = 0

local function findPOIs(me)
    v.poi = {}
    local p
    for i = 1,99 do
        p = getNode("poi" .. i)
        if p ~= 0 then
            table.insert(v.poi, p)
        end
    end
end

local function getRandomPOI()
    local u = #v.poi
    if u == 0 then return 0 end
    return v.poi[math.random(u)]
end

function init(me)
	setupEntity(me)
	entity_setEntityType(me, ET_NEUTRAL)
	entity_initSkeletal(me, "krotite")	
	
	entity_scale(me, 0.6, 0.6)
	
	entity_setState(me, STATE_IDLE)
	
		
	--local glow = entity_getBoneByName(me, "Glow")
	--local noteBone = entity_getBoneByName(me, "Note")
	
	--bone_setVisible(glow, 0)
	--bone_setVisible(noteBone, 0)
    
    v.idletimer = math.random() * 5
    
    findPOIs(me)
end

function postInit(me)
	v.n = getNaija()
	entity_setTarget(me, v.n)
end

function update(me, dt)

    if entity_isState(me, STATE_WSHOCKED) and not entity_isAnimating(me) then
        entity_setState(me, STATE_WORSHIP2)
    end
    
    if entity_isState(me, STATE_IDLE) then
        if v.gopoi == 0 then
            if v.idletimer < dt then
                v.idletimer = 1 + math.random() * 8 -- FIXME
                local p = getRandomPOI()
                if p ~= 0 then
                    --entity_swimToNode(me, p)
                    v.gox, v.goy = v.node_getRandomPoint(p)
                    entity_swimToPosition(me, v.gox, v.goy)
                    v.gopoi = p
                    --debugLog("krotite swim to " .. node_getName(p))
                end
            else
                v.idletimer = v.idletimer - dt
            end
        else
            if entity_isPositionInRange(me, v.gox, v.goy, 100) then
                entity_stopFollowingPath(me)
                v.gopoi = 0
                entity_rotate(me, 0, 1.3)
                entity_animate(me, "idle", -1) -- FIXME
                v.idletimer = 1 + math.random() * 20 -- FIXME
            end
        end
    end
end

function msg(me, s, x)
    if s == "worship" then
        entity_setState(me, STATE_WORSHIP)
    elseif s == "worship2" then
        entity_setState(me, STATE_WORSHIP2)
    elseif s == "wshock" and entity_isState(me, STATE_WORSHIP2) then
        entity_setState(me, STATE_WSHOCKED)
    end
    
end

function enterState(me)
	if entity_isState(me, STATE_IDLE) then
		entity_animate(me, "idle", -1)
    else
        entity_stopFollowingPath(me)
    end
    
	if entity_isState(me, STATE_WORSHIP) then
		entity_animate(me, "worship", -1)
    elseif entity_isState(me, STATE_WORSHIP2) then
		entity_animate(me, "worship2", -1)
    elseif entity_isState(me, STATE_WSHOCKED) then
		entity_animate(me, "worshipshock", 1)
	end
end

function exitState(me)
end

function damage(me, attacker, bone, damageType, dmg)
	return false
end

function animationKey(me, key)
end

function hitSurface(me)
end

function songNote(me, note)
end

function songNoteDone(me, note)
end

function song(me, song)
end

function activate(me)
end

