
-- in case anyone ever touches the code in here:
-- BEWARE! Its really, really fragile!
-- Took me a long time of experimenting and hacking to get this right

local Chars = {} -- "class" def here!

v.chars = {}

dofile("scripts/char_factory.lua")

dofile("scripts/char_naija.lua")
dofile("scripts/char_li.lua")
dofile("scripts/char_elena.lua")
dofile("scripts/char_lucien.lua")
dofile("scripts/char_krotite.lua")


local function setupGroup()
    -- always init active char first
    for i,chr in pairs(v.chars) do
        if chr:isActive() then
            v.restoreData(chr, true, true)
            break
        end
    end
    for i,chr in pairs(v.chars) do
        if not chr:isActive() then
            v.restoreData(chr, false, true)
        end
    end
end

local function isMapTrans()
    return v.getNumFlag("temp_chars_maptrans") ~= 0
end

local function setMapTrans(on)
    if on then
        v.setNumFlag("temp_chars_maptrans", 1)
        debugLog("-- set map trans: YES")
    else
        v.setNumFlag("temp_chars_maptrans", 0)
        debugLog("-- set map trans: NO")
    end
end

local function getPlayableChar()
    local c = getFlag(FLAG_CURRENT_CHAR)
    for i = FLAG_CHAR_START, FLAG_CHAR_END do
        if getFlag(i) == CHARSTATE_FORCE then
            local real = i - FLAG_CHAR_START -- = char ID
            if real ~= c then
                setFlag(FLAG_CURRENT_CHAR, real)
            end
            return real
        end
    end
    return c
end


Chars.init = function()
    Chars.fadetimer = 0
    Chars.curId = CHAR_NAIJA  -- this is always the case, as the engine does it. will switch in update() if it shouldn't be Naija.
    
    -- correct in case it was neg. number. (switch on map change - now the map was changed!)
    local c = v.getCharacter()
    if c < 0 then
        v.setCharacter(-c)
    end
    getPlayableChar() -- force detection & apply of override, if present
    setFlag(FLAG_BLOCK_CHANGE_CHAR, 0)
    
    for i,chr in pairs(v.chars) do
        chr.init()
    end
end

Chars.postInit = function()

    setupGroup()

    for i,chr in pairs(v.chars) do
        chr.postInit()
    end
    
    -- HACK: when beeing naija, a change will not be detected...
    -- force correct initialization at this point
    if v.isNaija() then
        setMapTrans(false)
        local chr = v.chars[CHAR_NAIJA]
        chr.start()
        setStringFlag("Char_name", chr.name)
        setStringFlag("Char_entname", chr.entityname)
    else
        Chars.preventSave = true -- we will switch anyway, and that resets this flag
    end
end

Chars.firstUpdate = true
Chars.preventSave = false

Chars.update = function(dt)

    local c = getPlayableChar()
    
    local chr = v.chars[Chars.curId]
    
    -- HACK: safeguard
    -- no, wrong. we should not try to save the day, otherwise this may break on map transition if char changes during that.
    --[[
    if (not chr)
    or (getFlag(chr.flag) == CHARSTATE_ELSEWHERE)
    or (getFlag(chr.flag) == CHARSTATE_NONEXIST) then
        c = -1
        debugLog("whoops, wrong char in action, forcing one that works")
        for ic, ichr in ipairs(v.chars) do
            if getFlag(ichr.flag) ~= 0 then
                c = ic
                break
            end
        end
        
        if c < 0 then
            centerText("WAAAH! GOT STUCK! Choosing Naija as last resort!")
            c = CHAR_NAIJA
            setFlag(FLAG_CHAR_NAIJA, CHARSTATE_PLAYABLE)
        end
        
        setFlag(FLAG_CURRENT_CHAR, c)
        
        chr = v.chars[c]
    end
    
    if not chr or not chr.me or chr.me == 0 then
        if not isMapTrans() then
            centerText("ERROR: " .. chr.name .. ".me undefined")
        end
        return
    end
    ]]
    
    
    chr.update(dt)
    
    if not Chars.firstUpdate and Chars.fadetimer <= 0 then -- this condition is a HACK
        v.charControlEntity(chr)
    end
    
    if c >= 0 and c ~= Chars.curId and Chars.fadetimer <= 0 and isFlag(FLAG_BLOCK_CHANGE_CHAR, 0) then
        debugLog("Detected character change: " .. Chars.curId .. " to " .. c)
        fadeOut(0.5)
        Chars.fadetimer = 0.5
        
        -- HACK
        if Chars.firstUpdate then
            Chars.preventSave = true
        end
        
        disableInput()
    end
    
    if Chars.fadetimer > 0 then
        Chars.fadetimer = Chars.fadetimer - dt
        if Chars.fadetimer <= 0 then
        
            -- HACK: prevent switching chars during death scene - can otherwise be used to skip death and continue
            if entity_getHealth(v.n) <= 0 then
                Chars.fadetimer = 0.3
                return
            end
            
            local newchr = v.chars[c]
            v.storeData(chr) -- calls chr.save()
            
            Chars.curId = c -- do it even if it fails. failure is temporary and does not matter when switching the map.
            if v.restoreData(newchr, true, false) then
                debugLog(chr.name .. " --- STOP")
                chr.stop()
                debugLog(newchr.name .. " --- START")
                newchr.start()
                setStringFlag("Char_name", newchr.name)
                setStringFlag("Char_entname", newchr.entityname)
                setMapTrans(false) -- FIXME: this is WRONG HERE
                
                -- HACK: trigger red damage overlay correctly appearing/hiding (see Avatar::onHealthChange())
                entity_heal(v.n, 0)
            else
                debugLog("restoreData failed, keeping old char (map transition?)")
            end
            
            fadeIn(0.5)
            Chars.preventSave = false
            enableInput()
        end
    end
    
    
    Chars.firstUpdate = false
end

Chars.onMapChange = function()
    local chr = v.chars[Chars.curId]
    v.storeData(chr)
end



v.logic.chars = Chars


--------- UTILITY FUNCTIONS ---------------

function v.initHealth(char)
    local maxhp = v.getNumFlag(char.name .. "_maxhp")
    
    if maxhp == 0 then
        debugLog("ERROR: no maxhp flag set for " .. char.name)
        return
    end
    
    local n = v.n
    
    entity_setHealth(n, maxhp)
    
    local curhp = v.getNumFlag(char.name .. "_hp")
    
    debugLog(char.name .. " initHealth max " .. maxhp .. " cur " .. curhp)
    
    -- blaaaarghh this code is convoluted... at least doesn't mess up anymore
    if curhp ~= 0 then -- can ignore == 0 case
        local diff = maxhp - curhp
        if curhp > maxhp then
            entity_setHealth(n, maxhp)
        else
            entity_changeHealth(n, -diff)
            debugLog(char.name .. " initHealth removing " .. diff .. " - now " .. entity_getHealth(n))
        end
    end
    -- TODO: sync with entity?
end

function v.storeCurrentHealth(char)
    local s =  tostring(entity_getHealth(v.n))
    debugLog("store health of " .. char.name .. ": " .. s)
    setStringFlag(char.name .. "_hp", s)
    -- TODO: sync with entity?
end

function v.storeData(char)

    local e = char.entity
    
    if not e or e == 0 then
        debugLog(char.name .. " data not stored - not on this map.")
        return
    end
    
    if Chars.preventSave then
        debugLog(char.name .. " data not stored - EXPLICITLY PREVENTED.")
        return
    end
    
    -- FIXME: i think this is no longer needed
    --if isMapTrans() then
    --    debugLog(char.name .. " data not stored - overridden by maptrans")
    --    return
    --end
    
    v.storeCurrentHealth(char) -- FIXME: is this place correct?
    char.save()

    local data =
    {
        x = entity_x(e)
        ,y = entity_y(e)
        ,map = getMapName()
    }
    
    local dump = v.DataDumper(data)
    debugLog(char.name .. " DUMP START")
    debugLog(tostring(dump))
    debugLog(char.name .. " DUMP END")
    setStringFlag(char.name .. "_data", dump)
    char.data = data
end

-- switch: if true, data of currently active char were just saved and we are switching to a new one
-- create: if true, create group entities (this is the case when the map is loaded)
function v.restoreData(char, switch, create)
    local sw = "no"
    local cr = "no"
    local tr = "no"
    if switch then sw = "yes" end
    if create then cr = "yes" end
    if isMapTrans() then tr = "yes" end
    
    debugLog("restoreData for " ..char.name .. " (switch: " .. sw .. ", create: " .. cr .. ", trans: " .. tr ..")")
    
    if not v.charId_isPlayable(char.id) then
        debugLog(" ... not playable, skipping")
        return
    end
    
    local dump = getStringFlag(char.name .. "_data")
    if not dump or dump == "" then
        centerText("ERROR: " .. char.name .. " restoreData failed - no data")
        return
    end
    
    debugLog(char.name .. " DATA DUMP FOLLOWS:")
    debugLog(dump)

    local f = loadstring(dump)
    local data = f()
    char.data = data
    
    debugLog(char.name .. " data restored")
    
    local thisMap = isMapName(data.map)
    local isPlayed = char:isActive() -- always true if switch is true
    
    if isPlayed ~= switch then
        centerText("ERROR: Logic messed up in logic_chars::restoreData(), oops")
        return
    end
    
    -- possible cases:
    --
    -- (1) - we are entering the map, and another character is somewhere
    --       -> create entity at stored position [create && !switch] + thisMap
    --
    -- (2) - we are on a map ~= this, change character, and get thrown to another map
    --       -> create entity at stored position, and warp avatar there [create && switch] + [!thisMap && isPlayed]
    --
    -- (3) - we are entering a map with currently played char, or reload current map
    --       -> create entity at avatar/v.n position [create && switch] - [thisMap && isPlayed]
    --
    -- (4) - we change character, and the target character is on the same map
    --       -> warp avatar to target entity [!create && switch] + [thisMap && isPlayed]
    
    -- checked in this order
    local entToAvatar = false -- (3)
    local entToStored = false -- (1) (2)
    local avatarToEnt = false --     (2) (4)
    
    local e
    local mustSave = false
    
    if switch and create then
        debugLog(" ... switch and create")
        if thisMap then
            debugLog(char.name .. " ... is already on target map")
            entToStored = true
        end
    end
    
    if thisMap then
        debugLog(" ... thisMap = true")
    else
        debugLog(" ... thisMap = false")
        if switch and isPlayed then 
            if create then
                -- case (2) -- arrived at dest map or another map
                debugLog(char.name .. " ... arrived on other map")
                mustSave = true
                entToAvatar = true
            else
                -- prepare (2) -> send to other map
                debugLog(char.name .. " ... is on map [" .. data.map .. "] ... going there")
                setMapTrans(true)
                loadMap(data.map)
                return false -- prevent changing char before actually getting there
            end
        elseif create then
            debugLog(" ... entity not created, not on this map")
            return
        end
    end
    
    -- case (4)
    if switch then
        avatarToEnt = true
        
        if not create and isMapTrans() then
            debugLog(" ... FORCE warp entity to stored")
            entToStored = true
        end
    end
    
    if create then
        e = char:getEntity() -- creates if not exist, and sets char.entity
        debugLog(" ... created entity: " .. entity_getName(e))
        if switch then
            if not isMapTrans() then
                debugLog(" ... must warp entity to avatar")
                entToAvatar = true
            end
        else
            debugLog(" ... must warp entity to stored")
            entToStored = true
        end
    else
        e = char.entity
        debugLog(" ... found entity: " .. entity_getName(e))
    end
    
    if not e or e == 0 then
        debugLog(" ... entity does not exist, skipping")
        return
    end
    
    if entToAvatar then
        debugLog(string.format(" ... setting entity to AVATAR position: %.3f, %.3f", entity_x(v.n), entity_y(v.n)))
        entity_setPosition(e, entity_x(v.n), entity_y(v.n))
    elseif entToStored then
        debugLog(string.format(" ... setting entity to STORED position: %.3f, %.3f", data.x, data.y))
        entity_setPosition(e, data.x, data.y)
    end
    
    if avatarToEnt then
        debugLog(string.format(" ... setting AVATAR to ENTITY position: %.3f, %.3f", entity_x(e), entity_y(e)))
        entity_setPosition(v.n, entity_x(e), entity_y(e))
        
        -- HACK: try to prevent displaying camera movement from top left corner
        setCameraLerpDelay(0)
        v.pushTQ(1, setCameraLerpDelay, 0.1) -- restore to default after 1 sec
    end
    
    if isPlayed then
        v.initHealth(char)
    end
    
    if mustSave then
        v.storeData(char)
    end
    
    return true
end

function v.charControlEntity(chr)
    local e = chr.entity
    if e == 0 then
        return
    end
    
    local n = v.n
    local nx, ny = entity_getPosition(n)
    
    entity_setPosition(e, nx, ny)
    
    --[[if avatar_isBursting() then
        -- if bursting, naija turns around when she's about to clamp to a wall; looks ugly.
        -- trying to prevent that here.
        entity_clearVel(e)
        local x, y = 0, -100
        x, y = v.vector_rotateDeg(x, y, entity_getRotation(n))
        entity_addVel(e, x, y)
        entity_rotateToVel(e)
    else]]
        entity_rotate(e, entity_getRotation(n))
    --end
    
    -- TODO: use entity_getAnimationName and a lookup table which entity supports which animation.
    -- sort of a translation table which naija anim should be mapped to which e anim.
    
    local vl = entity_getVelLen(n)
    
    local curanim = entity_getAnimationName(e)
    local isAnim = entity_isAnimating(e)
    local isSwim = curanim == "swim" and isAnim
    local isBurst = curanim == "burst" and isAnim
    local isIdle = curanim == "idle"
    
    if avatar_isBursting() and not isBurst then
        entity_animate(e, "burst", nil, nil, -1) -- no delay
    elseif vl >= 200 and not isSwim and not isBurst then -- 300 is slow swim speed
        entity_animate(e, "swim", LOOP_INF)
    elseif vl <= 70 and not isIdle then
        entity_animate(e, "idle", LOOP_INF)
    end
   
    if entity_isfh(n) ~= entity_isfh(e) then
        entity_fh(e)
    end
    -- note: the game never does vertical flip on Naija.
    
    
    
    ---- TODO LIST ----
    -- rolling
    -- clamping to walls
    -- damage anim + damage naija<->entity sync

end


-- BELOW HERE not used i think -------------------
--[[
function v.getCharTable(c)
    if type(c) == "number" then
        c = v.chars[c]
    end
    
    if type(c) == "table" then
        return c
    end
    
    centerText("ERROR: getCharTable(" .. c .. ") fail")
    return nil
end

function v.char_getStateFlag(c)
    local c = v.getCharTable(c)
    return v.char_getStateFlag(c)
end
]]

