
local Debug = {} -- "class" def here!

Debug.text = 0

local function dbgSetFlags(on)
    if on then on = 1 else on = 0 end
    
    setFlag(FLAG_DBG_SPAWNALWAYS, on)
    setFlag(FLAG_DBG_VISUALS, on)
    setFlag(FLAG_CAN_USE_CRYSTAL_POWER, on)
    --setFlag(FLAG_NO_HEAT_DAMAGE, on)
    setFlag(FLAG_PET_NAMESTART+4, on)
    
    setFlag(FLAG_HAS_ENERGY2, on)
    setFlag(FLAG_HAS_SHIELD2, on)
    setFlag(FLAG_HAS_SUNBEAM, on)
    
    setTimerTextAlpha(on and 0.6 or 0, 1.5)
end

local function dbgCheckGlobalFlags()
    local err = ""
    local taken = {}
    for a, x in pairs(_G) do
        if type(x) == "number" and a:startsWith("FLAG_") then
            if taken[x] then
                if not (a:endsWith("START") or a:endsWith("_END") or taken[x]:endsWith("START") or taken[x]:endsWith("_END")) then
                    err = err .. "\nDbl def flag: " .. a .. " = " .. x .. " ( = " .. taken[x] .. ")"
                end
            else
                taken[x] = a
            end
        end
    end
    
    if #err > 0 then
        debugLog(err)
        centerText(err)
    end
end
            

Debug.blackout = false

Debug.init = function()

    setFlag(FLAG_NO_HEAT_DAMAGE, 1)
    
    if v.isDebug() then
        setControlHint("Debug mode active!", false, false, false, 1.5, "youngli/head")
        dbgSetFlags(true) -- be sure all debug is really enabled on debug maps
    else
        dbgSetFlags(false)
    end
    
    
    if isMapName("crtest") or isMapName("dbg") then
        setFlag(FLAG_ENABLE_RING_UI, 1) -- TEMP HACK: this will be set once there are more than 2 chars to select
        
        setFlag(FLAG_CHAR_NAIJA, CHARSTATE_PLAYABLE)
        setFlag(FLAG_CHAR_LI, CHARSTATE_PLAYABLE)
        setFlag(FLAG_CHAR_ELENA, CHARSTATE_PLAYABLE)
        --setFlag(FLAG_CHAR_KROTITE, CHARSTATE_PLAYABLE)
        setFlag(FLAG_CHAR_LUCIEN, CHARSTATE_PLAYABLE)
        
        
        if getStringFlag("TEMP_debug_inited") ~= "true" then
        
            learnSong(100) -- song of power
            learnSong(101) -- song of cure
            learnSong(102) -- song of echo
            learnSong(150) -- DEBUG BOMB
            learnSong(155) -- LUFIA
            
            -- HACK: trigger map reload to really init everything properly
            Debug.blackout = true
            --warpAvatar(getMapName(), entity_getPosition(getNaija()))
            loadMap(getMapName())
            
            setStringFlag("TEMP_debug_inited", "true") -- HACK
        end
    end
end

Debug.postInit = function()

    dbgCheckGlobalFlags()
    
    debugLog("debug: Lua version: " .. _VERSION)
    debugLog("debug: Lua mem in use: " .. collectgarbage("count") .. " KB")
    
    if rawget(_G, "jit") then
        debugLog("debug: LuaJIT detected!")
        debugLog("debug: LuaJIT version: " .. jit.version)
        debugLog("debug: LuaJIT OS: " .. jit.os)
        debugLog("debug: LuaJIT arch: " .. jit.arch)
    else
        debugLog("debug: Using original Lua")
    end
    
    --v.forAllNodes(function(node)
    --    debugLog("-found node: [" .. node_getName(node) .. "]")
    --end)
    
    --[=[
    v.pushTQ(1.5, function()
        debugLog("msg test")
        local a = createEntity("logichelp_a")
        local b = createEntity("logichelp_b")
        local x, y = entity_getPosition(v.n)
        entity_setPosition(a, x, y)
        entity_setPosition(b, x, y)
        
        --entity_msg(b, "hi", 1, 2, 3, 4, 5, {1}, setmetatable({}, {__tostring=function() return "barf" end}))
        local r = { entity_msg(b, "sum", 1,2,3) }
        local s = ""
        for i, x in pairs(r) do
            s = s .. "[" .. i .. "]: " .. tostring(x) .. "\n"
        end
        centerText("\n\nrets:\n" .. s)
        --entity_msg(b, "me", a)
        
        --[[
        local r = entity_msg(a, "hi")
        if r then
            debugLog("1a: " .. r)
        end
        r = entity_msg(a, "ho", b)
        if r then
            debugLog("2a: " .. r)
        end
        ]]
        debugLog("msg test over")
    end)
    ]=]
    
    --[[Debug.text = createDebugText("Hello world", 10, 400, 300)
    obj_setLayer(Debug.text, 53) -- LR_SCENE_COLOR
    obj_rotate(Debug.text, 360, 3, -1)]]
    
end

local function updatePeriodic1()
    --setTimerText(v.getNumFlag("Naija_cetime"))
    
    
    --[[local x, y = entity_getPosition(v.n)
    local s = 2000
    isLineObstructed(x, y, x+s, y)
    isLineObstructed(x, y, x-s, y)
    isLineObstructed(x, y, x, y+s)
    isLineObstructed(x, y, x, y-s)
    
    isLineObstructed(x, y, x+s, y+s)
    isLineObstructed(x, y, x+s, y-s)
    isLineObstructed(x, y, x-s, y+s)
    isLineObstructed(x, y, x-s, y-s)
    ]]
    
    --[[
    local viewUp = 20
    local viewDown = 40
    
    local b = entity_getBoneByIdx(v.n, 1)
    local bx, by = bone_getWorldPosition(b)
    local nx, ny = entity_getHeadLookVector(v.n, b, 0)
    nx = nx * 800
    ny = ny * 800
    isLineObstructed(bx + nx / 30, by + ny / 30, bx + nx, by + ny)
    local sx, sy = bx - 600, by - 500
    local ex, ey = bx + 600, by + 500
    for y = sy, ey, 30 do
        for x = sx, ex, 30 do
            if isPointInArc(bx, by, nx, ny, viewUp, viewDown, x, y) then
                --spawnParticleEffect("awesomedebug2", x, y)
            else
                --spawnParticleEffect("awesomedebug", x, y)
            end
        end
    end
    
    local head = entity_getBoneByIdx(v.n, 1)
    local mx, my = getMouseWorldPos()
    if entity_canSeePoint(v.n, head, mx, my, 1400, viewUp, viewDown, 0) then
        debugLog("can see")
    else
        debugLog("can NOT see")
    end
    ]]
    
    
    
    
end
    
Debug.t = 0

Debug.update = function(dt)
    if v.isDebug() then
		if entity_getHealthPerc(v.n) <= 0.4 then
			cureAllStatus()
			setControlHint("DEBUG Healing", 0, 0, 0, 1)
			entity_heal(v.n,3)
		end
        
        if Debug.t >= 0 then
            Debug.t = Debug.t - dt
            if Debug.t <= 0 then
                updatePeriodic1()
                Debug.t = 0.1
            end
        end
    end
    
    if Debug.blackout then
        fade(1, 0, 0, 0, 0)
    end
    
    local d = getFlag(FLAG_DBG_TOGGLE)
    if d == 1 then
        dbgSetFlags(true)
        setFlag(FLAG_DBG_TOGGLE, 0)
        setFlag(FLAG_DBG, 1) -- HACK
        setFlag(FLAG_RELOAD_UI, 1)
    elseif d == 2 then
        dbgSetFlags(false)
        setFlag(FLAG_DBG_TOGGLE, 0)
        setFlag(FLAG_DBG, 0) -- HACK
        setFlag(FLAG_RELOAD_UI, 1)
    end
    
end


v.logic.debug = Debug
