
local IFHooks = {} -- "class" def here!


-- HACK HACK HACK HACK HACK !!!


-- this function is hooked onto every entity's damage() callback.
-- see trigger_energylight.lua for an idea why.
-- It is because shots spawn entities only when they hit a WALL, not other entites.
-- And this trigger entity is required to spawn a quad on the dark layer that flashes the place where the shot impact was.
-- Instead of modifying *ALL* entity scripts and adding an appropriate check, we use a hook and are done.
-- Happy monkey patching!
local function entityhook_damage_energyblastglow(me, attacker, bone, damageType, dmg, hx, hy, shot)
    -- FIXME: this is just a test for now.
    -- TODO: should also work for an NPC Naija (if AI-controlled)
    if damageType == DT_AVATAR_ENERGYBLAST or damageType == DT_AVATAR_SHOCK then
        local q = createQuad("softglow-add", 13)
        quad_setPosition(q, shot_getPosition(shot))
        quad_setBlendType(q, BLEND_ADD)
        quad_color(q, 0.95, 0.45, 0.08)
        quad_scale(q, 1, 1)
        quad_scale(q, 4, 4, 0.4)
        quad_alpha(q, 1)
        quad_alpha(q, 0, 0.5)
        quad_delete(q, 0.5)
    end
end

local function entityhook_enterState_memprotect(me)
    if entity_isState(me, STATE_DEATHSCENE) or entity_isState(me, STATE_DEAD) then
        entity_markDeleted(me)
    end
end



--IFHooks.txt = false

local function entityhook_msg_dump(me, s, ...)
    --[[if IFHooks.txt and type(s) == "string" then
        table.insert(IFHooks.txttab, string.format("[%s]: %s", entity_getName(me), s))
        if #IFHooks.txttab > 30 then
            table.remove(IFHooks.txttab, 1)
        end
        text_setText(IFHooks.txt, table.concat(IFHooks.txttab, "\n"))
    end]]
    
    if type(s) == "string" then
        debugLog(string.format("msg [%s]: %s", entity_getName(me), s))
    end
end


IFHooks.init = function()

    --[[
    IFHooks.txttab = {}
    IFHooks.txt = createDebugText("Hello world", 5, 600, 10)
    obj_setLayer(IFHooks.txt, 53) -- LR_SCENE_COLOR
    ]]

    beginEntityInterfaceHooks()

    enqueueEntityInterfaceHook("energyblastglow", "damage", entityhook_damage_energyblastglow)
    enqueueEntityInterfaceHook("memprotect", "enterState", entityhook_enterState_memprotect)
    --enqueueEntityInterfaceHook("msgdump", "msg", entityhook_msg_dump)
    -- ....
    
    applyEntityInterfaceHooks()
end

IFHooks.postInit = function()
end
    

IFHooks.update = function(dt)
end

IFHooks.onMapChange = function()
    --obj_alpha(IFHooks.txt, 0, 0.25)
    --IFHooks.txt = nil
end


v.logic.interfacehooks = IFHooks

