
local MCD = {}

MCD.init = function()
    MCD.triggered = false
end

MCD.update = function()
    --[[
    Okay, so there is no API to detect when the map is changed.
    So hereby i present THE MEGA HACK - see Avatar.cpp:
        void Avatar::onWarp()
        {
            avatar->setv(EV_NOINPUTNOVEL, 0);
            closeSingingInterface();
        }
        
    -- EV_NOINPUTNOVEL is not really used anywhere else,
    -- so relying on this check here should be somewhat safe.
    -- Note: The original node_sit and node_sleep use it,
    -- but mine are modified enough that it is not necessary.
    -- Cool is that it also works when reloading a map in the editor.
    -- If this ever goes off unexpectedly, check if EV_NOINPUTNOVEL is used anywhere !!
    ]]
    if not MCD.triggered and egetv(v.n, EV_NOINPUTNOVEL) == 0 then
        MCD.triggered = true
        debugLog("logic_mapchangedetector: detected map change!")
        for k, f in pairs(v.logic) do
            if f.onMapChange then
                f.onMapChange()
            end
        end
    end
    
    if MCD.triggered and v.isDebug() then
        entity_clearVel(v.n)
        entity_clearVel2(v.n) -- prevent smear
        entity_debugText(v.n, "logic_mapchangedetector:\ndetected map change!") -- spam
    end
end


v.logic.mcd = MCD
