
-- precache textures and sound files and keep them used so the game does not free them
-- this should be done for custom forms/costumes, shots, particles, and any other non-static textures.
-- This prevents slight pauses in game flow while the engine is busy loading data off disk repeatedly.

local Precache = {} -- "class" def here!

local tex =
{
    "naija/dark-backarm1",
    "naija/dark-backarm2",
    "naija/dark-backleg1",
    "naija/dark-backleg2",
    "naija/dark-backleg3",
    "naija/dark-body",
    "naija/dark-frontarm1",
    "naija/dark-frontarm2",
    "naija/dark-frontleg1",
    "naija/dark-frontleg2",
    "naija/dark-frontleg3",
    "naija/dark-head-blink",
    "naija/dark-head-pain",
    "naija/dark-head-shock",
    "naija/dark-head-singing",
    "naija/dark-head-smile",
    "naija/dark-head",
    
    "naija/na-head-blink",
    "naija/na-head-pain",
    "naija/na-head-shock",
    "naija/na-head-singing",
    "naija/na-head-smile",
    "naija/na-head",
    
    "shots/miablasthead",
    "powerlines",
    "powerlinesblue",
    "sunbeam",
}


local snd =
{
}

local trig =
{
    "trigger_energylight",
    "trigger_raspberrydouble",
}



Precache.init = function()
    local q
    for _,t in pairs(tex) do
        q = createQuad(t)
        quad_alpha(q, 0) -- effectively turns off rendering
    end
    
    for _,s in pairs(snd) do
        loadSound(s)
    end
    
    for _,s in pairs(trig) do
        local e = createEntity(s)
        entity_msg(e, "_resident") -- see template_trigger.lua
    end
    
    debugLog("PRECACHE LOGIC: done " .. #tex .. " textures")
    debugLog("PRECACHE LOGIC: done " .. #snd .. " sounds")
    debugLog("PRECACHE LOGIC: done " .. #trig .. " triggers")
end

Precache.postInit = function()
    v.logic.Precache = nil
end
    

Precache.update = function(dt)
end


v.logic.Precache = Precache
