if not v then v = {} end

local SUNBEAM_CHARGE_TIME = 3
local SUNBEAM_ACTIVE_TIME = 3
local SUNBEAM_OFFS = 70

local Sunbeam = {} -- "class" def here!

Sunbeam.tcharge = 0
Sunbeam.charged = false
Sunbeam.cursor = 0
Sunbeam.beam = 0
Sunbeam.beamtimer = 0


local function updateBeam(b)
    local n = getNaija()
    local x, y = entity_getPosition(n)
    local mx, my = vector_normalize(entity_getVectorToEntity(n, Sunbeam.cursor))
    
    local a = (math.atan2(my, mx) * RADTODEG) + 90
    --local a = entity_getRotation(n)
    
    beam_setPosition(b, x + (mx * SUNBEAM_OFFS), y + (my * SUNBEAM_OFFS)) -- need to add a bit of space, otherwise naija will be hurt
    beam_setAngle(b, a)
end

local function calcBeamPower()
    local w = 10
    local p = 0.1

    local np = v.calcNaijaPower()
    
    w = w + (np * 30)
    p = p + (np * 0.7)
    
    return w, p
end


local function doCharge()

end

local function finishCharge()
    Sunbeam.charged = true
    local x, y = entity_getPosition(getNaija())
    spawnParticleEffect("greenpower", x, y)
    playVisualEffect(VFX_RIPPLE, x, y)
    playVisualEffect(2, x, y) -- undocumented; weird energy-like circle, but looks cool
    playSfx("powerup")
end

local function releaseCharge()
    Sunbeam.charged = false
    
    -- just in case
    if Sunbeam.beam ~= 0 then
        beam_delete(Sunbeam.beam)
    end
    
    Sunbeam.beamtimer = SUNBEAM_ACTIVE_TIME
    local b = createBeam(0, 0, 0, 1) -- will be set later
    Sunbeam.beam = b
    
    beam_setTexture(b, "sunbeam")
    updateBeam(b)
    
    local w, p = calcBeamPower()
    beam_setBeamWidth(b, w)
    beam_setDamage(b, p)
    
    
    playSfx("fizzlebarrier")
end

Sunbeam.init = function()
    Sunbeam.cursor = v.cursor
end

Sunbeam.postInit = function()
    -- re-hook function to be called only when naija is currently active
    table.insert(v.chars[CHAR_NAIJA].updatefuncs, Sunbeam.update)
    v.logic.sunbeam = nil
end
    

Sunbeam.update = function(dt)

    if getFlag(FLAG_HAS_SUNBEAM) == 0 then
        return
    end

    if isForm(FORM_SUN) then
        local c = avatar_getSpellCharge()
        if c == 0 then
            if Sunbeam.tcharge >= SUNBEAM_CHARGE_TIME then
                releaseCharge()
            end
        elseif c < SUNBEAM_CHARGE_TIME then
            doCharge()
        else
            if not Sunbeam.charged then
                finishCharge()
            end
        end
        
        Sunbeam.tcharge = c
    else
        Sunbeam.tcharge = 0 -- prevent "storing" energy by switching to other form and later back
        Sunbeam.beamtimer = 0
        Sunbeam.charged = false
    end
    
    local b = Sunbeam.beam
    if b ~= 0 then
        if Sunbeam.beamtimer > 0 then
            updateBeam(b)
            Sunbeam.beamtimer = Sunbeam.beamtimer - dt
        else
            beam_delete(b)
            Sunbeam.beam = 0
        end
    end
        
    
end


v.logic.sunbeam = Sunbeam
