
local UI = {} -- "class" def here!

local STATE_CLICKED = 1337
local NEAR_NAIJA_SQR = 50 * 50
local DBLCLICK_TIMER = 0.5
local DELAY_TIMER = 0.35

UI.clicktimer = 0
UI.visible = false
UI.wasLMB = false
UI.delay = 0

UI.elemcount = 0

local function setElementValue(e, ev, val)
    entity_msg(e, ev)
    entity_msg(e, tostring(val))
end

local function addElement(tex, x, y, scale, a, callback, light)
    debugLog("add gui elem x: " .. x .. "  y: " .. y) 
    local e = createEntity("guielement")
    
    local f = function()
        setElementValue(e, "tex",   tex     )
        setElementValue(e, "x",     x       )
        setElementValue(e, "y",     y       )
        if scale then setElementValue(e, "scale", scale   ) end
        if a     then setElementValue(e, "a",     a       ) end
        if light then setElementValue(e, "light", light   ) end
        entity_msg(e, "initdone")
        --debugLog("-- gui element inited:" .. tex)
    end
    
    UI.elems[e] = callback
    table.insert(UI.deferredCalls, f)
    UI.elemcount = UI.elemcount + 1
    return e
end

local function bTestCallback()
    shakeCamera(30, 0.5)
    setFlag(FLAG_RELOAD_UI, 1)
    
    -- MEGA HACK
    entity_delete(getEntity("logichelp_entitydeath"))
    v.setNumFlag("Naija_ce", CE_NONE)
    v.setNumFlag("Naija_cetime", 0)
    v.setNumFlag("Naija_cekills", 0)
    createEntity("logichelp_entitydeath", "", entity_x(v.n), entity_y(v.n))
end

local function bNaijaCallback()
    setFlag(FLAG_CURRENT_CHAR, CHAR_NAIJA)
    --v.edbg(getNaija(), string.format("Naija power: %.3f", v.calcNaijaPower()), 6)
end

local function bElenaCallback()
    setFlag(FLAG_CURRENT_CHAR, CHAR_ELENA)
end

local function bLiCallback()
    setFlag(FLAG_CURRENT_CHAR, CHAR_LI)
end

local function bLucienCallback()
    setFlag(FLAG_CURRENT_CHAR, CHAR_LUCIEN)
end

local function bKrotiteCallback()
    setFlag(FLAG_CURRENT_CHAR, CHAR_KROTITE)
end

local function bSummonLiCallback()

    local s = "aitest"
    local e = getEntity(s)
    
    if e == 0 then
        for i = 1, 5 do
            e = createEntity(s)
            entity_setPosition(e, entity_x(v.n), entity_y(v.n))
        end
    else
        for _, e in pairs(getAllEntities()) do
            if entity_isName(e, s) then
                entity_changeHealth(e, -99)
            end
        end
    end
        
--[[
    local li = getEntity("li_test") --= getLi()
    if li == 0 then
        --li = createEntity("li")
        li = createEntity("li_test")
        --setLi(li)
        entity_setPosition(li, entity_x(v.n), entity_y(v.n))
    else
        --setLi(0) -- OOPS: gives a warning, too bad.
        entity_delete(li)
    end
]]
end

local function bSpawnBombCallback()
    createEntity("libomb", "", entity_x(v.n), entity_y(v.n))
end

local function bToggleDebugCallback()
    if v.isDebug() then
        setFlag(FLAG_DBG_TOGGLE, 2) -- disable
        playSfx("denied")
    else
        setFlag(FLAG_DBG_TOGGLE, 1) -- enable
        playSfx("secret")
    end
    --setControlHint("Reload the map to toggle debug visuals as well", false, false, false, 1)
end

local function incrCirclePos(x, y, totalElem)
    return v.vector_rotateDeg(x, y, 360 / totalElem)
end

local function addElementCentered(tex, x, y, scale, a, callback, light)
    --local cx, cy = getScreenCenter() -- this is definitely wrong
    --local cx, cy = entity_getPosition(v.n) -- not inited, BAD
    --cx, cy = toWindowFromWorld(cx, cy)
    --debugLog("center x: " .. cx .. "  y: " .. cy)
    local cx, cy = 400, 300
    return addElement(tex, x + cx, y + cy, scale, a, callback, light)
end


-- possibly called multiple times
UI.init = function()
    UI.elemcount = 0
    if UI.elems then
        for e,_ in pairs(UI.elems) do
            entity_delete(e)
        end
    end
    
    UI.elems = {}
    UI.deferredCalls = {}
    
    if getFlag(FLAG_ENABLE_RING_UI) == 0 then
        return
    end
    
    local totalElem = 8 -- FIXME or find something that looks good
    local x, y = 0, -70 -- radius
    
    local light = 0.5
    local alpha = 1
    
    --- CHARACTERS ----
    
    if v.charId_isPlayable(FLAG_CHAR_NAIJA) then
        addElementCentered("naija/naija2-head", x, y, 0.7, alpha, bNaijaCallback, light)
        x, y = incrCirclePos(x, y, totalElem)
    end
    
    if v.charId_isPlayable(FLAG_CHAR_LI) then
        addElementCentered("li/head", x, y, 0.7, alpha, bLiCallback, light)
        x, y = incrCirclePos(x, y, totalElem)
    end
    
    if v.charId_isPlayable(FLAG_CHAR_ELENA) then
        addElementCentered("naija/mutant-head", x, y, 0.7, alpha, bElenaCallback, light)
        x, y = incrCirclePos(x, y, totalElem)
    end
    
    if v.charId_isPlayable(FLAG_CHAR_LUCIEN) then
        addElementCentered("lucien/lucien-head", x, y, 0.7, alpha, bLucienCallback, light)
        x, y = incrCirclePos(x, y, totalElem)
    end
    
    if v.charId_isPlayable(FLAG_CHAR_KROTITE) then
        addElementCentered("krotite/head", x, y, 0.7, alpha, bKrotiteCallback, light)
        x, y = incrCirclePos(x, y, totalElem)
    end
    
    --- DEBUG STUFF ----
    
    if v.logic.debug then
        local s = "redbug"
        if v.isDebug() then s = "greenbug" end
        addElementCentered(s, x, y, 0.33, alpha, bToggleDebugCallback, light)
        x, y = incrCirclePos(x, y, totalElem)
    end
    
    if v.isDebug() then
        addElementCentered("gui/wok-drop", x, y, 0.5, alpha, bTestCallback, light)
        x, y = incrCirclePos(x, y, totalElem)
        
        addElementCentered("li/helmet", x, y, 0.7, alpha, bSummonLiCallback, light)
        x, y = incrCirclePos(x, y, totalElem)
        
        addElementCentered("libomb", x, y, 1.2, alpha, bSpawnBombCallback, light)
        x, y = incrCirclePos(x, y, totalElem)
    end
    
    
    
    --[[
    -- OLD bottom bar code, has problems with large zoom out
    
    local x = 350
    local y = 555
    
    addElement("gui/wok-drop", x, y, 0.5, 0.5, bTestCallback)
    x = x + 50
    
    addElement("naija/naija2-head", x, y, 0.7, 0.5, bNaijaCallback)
    x = x + 50
    
    if getFlag(FLAG_CHAR_ELENA) == 1 then
        addElement("naija/mutant-head", x, y, 0.7, 0.5, bElenaCallback)
        x = x + 50
    end
    
    ]]
end

UI.postInit = function()
    --UI.cursor = getEntity("logichelp_cursorpos")
end

local function debugOutput()
    if not v.isDebug() then return end
    
    debugLog(string.format("char states: %d %d %d %d", getFlag(FLAG_CHAR_NAIJA), getFlag(FLAG_CHAR_LI), getFlag(FLAG_CHAR_ELENA), getFlag(FLAG_CHAR_LUCIEN)))
end

local function showAll()
    --debugLog("-showAll-")
    debugOutput()
    for e,_ in pairs(UI.elems) do
        entity_msg(e, "show")
    end
    UI.visible = true
    UI.delay = DELAY_TIMER
    playSfx("urchin-hit")
end

local function hideAll()
    --debugLog("-hideAll-")
    for e,_ in pairs(UI.elems) do
        entity_msg(e, "hide")
    end
    UI.visible = false
    UI.delay = DELAY_TIMER
    playSfx("popshell")
end
    

UI.update = function(dt)

    if getFlag(FLAG_RELOAD_UI) ~= 0 then
        UI.init()
        setFlag(FLAG_RELOAD_UI, 0)
    end
    
    if next(UI.elems) == nil or UI.elemcount <= 1 then
        return
    end
    
    if UI.delay > 0 then
        UI.delay = UI.delay - dt
    end
    
    local lmb = isLeftMouse()
    if lmb and UI.delay <= 0 then
        if UI.visible then
            if not UI.wasLMB then
                hideAll()
            end
        elseif isForm(FORM_NORMAL) and entity_isState(v.n, STATE_IDLE) then -- HMM: why limit this? I think this is better.
            local mx, my = getMouseWorldPos()
            local nx, ny = entity_getPosition(v.n)
            local dx = mx - nx
            local dy = my - ny
            local distsq = dx*dx + dy*dy
            if distsq < NEAR_NAIJA_SQR then
                if UI.clicktimer <= 0 then
                    UI.clicktimer = DBLCLICK_TIMER
                elseif UI.clicktimer < DBLCLICK_TIMER then
                    showAll()
                end
            else
                UI.clicktimer = 0
            end
        end
    else
        if UI.clicktimer > 0 then
            UI.clicktimer = UI.clicktimer - dt
        end
    end
    
    if UI.visible and not (isForm(FORM_NORMAL) and entity_isState(v.n, STATE_IDLE)) then -- HMM: why limit this? I think this is better.
        hideAll()
    end

    -- first-time init
    if UI.deferredCalls then
        for e,dc in pairs(UI.deferredCalls) do
            dc()
        end
        UI.deferredCalls = nil
        return
    end
    
    for e,cb in pairs(UI.elems) do
        if entity_isState(e, STATE_CLICKED) then
            entity_setState(e, STATE_IDLE)
            if cb ~= 0 then
                cb(e)
            end
            hideAll()
        end
    end
    
    UI.wasLMB = lmb
end


v.logic.ui = UI
