-- Copyright (C) 2007, 2010 - Bit-Blot
--
-- This file is part of Aquaria.
--
-- Aquaria is free software; you can redistribute it and/or
-- modify it under the terms of the GNU General Public License
-- as published by the Free Software Foundation; either version 2
-- of the License, or (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
--
-- See the GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

if not v then v = {} end
if not AQUARIA_VERSION then dofile("scripts/entities/entityinclude.lua") end

dofile("scripts/inc_flags.lua")


function init(me)
	setupEntity(me)
	entity_setEntityType(me, ET_NEUTRAL) -- by making the entity neutral, normal shots won't target this
    
    entity_setTexture(me, "missingimage")
    
    if getFlag(FLAG_DBG_VISUALS) == 0 then
        entity_alpha(me, 0.001) -- setting this to 0.0 makes shots unable to follow it.
    end
    
    if v.isDebug() then
        esetv(me, EV_LOOKAT, 1)
        entity_setNaijaReaction(me, "shock")
    else
        esetv(me, EV_LOOKAT, 0)
    end
	
	entity_setAllDamageTargets(me, false)
    entity_setUpdateCull(me, -1)
    
    entity_setDamageTarget(me, DT_AVATAR_ENERGYBLAST, true) -- however, its still a valid target for manually spawned shots
    entity_setDamageTarget(me, DT_AVATAR_SHOCK, true)
	
	entity_setCollideRadius(me, 1)
	
	entity_setCanLeaveWater(me, true)
    
end



function postInit(me)
end

function update(me, dt)
    entity_setPosition(me, getMouseWorldPos())
end

function enterState(me)
end

function exitState(me)
end

function msg(me, msg)
end

function damage(me, attacker, bone, damageType, dmg)
	return false
end

function animationKey(me, key)
end

function hitSurface(me)
end

function songNote(me, note)
end

function songNoteDone(me, note)
end

function song(me, song)
end

function activate(me)
end

