
-- note: this entity is only active if naija is the current active character.

-- it keeps track of killed entites and is the main extra handler
-- for crystal effect auras.
-- quite hackish tho, and the code is too messy for my liking (sorry)

-- FIXME: rename this to logichelp_auras.lua at some point


dofile("scripts/inc_flagfunc.lua")
dofile("scripts/inc_util.lua")
dofile("scripts/inc_timerqueue.lua")

local SAVE_INTERVEL = 1

local OVERPOWER_MADNESS_MULTI = 8

v.n = 0

v.efftimer = 0
v.effrefresh = 0
v.eff = CE_NONE

v.isn = 0
v.fxtimer = 0

v.effdata = 0

v.canEmote = true

v.savetimer = 0

v.ticktimer = 0


-- CE power
local POW_CHARGES_CAP = 9999 -- do we really need a cap? better, because massive munching in beast form can drive this value quite high...
                             -- otoh, it gets reset when the effect ends or is changed, so why not...
local POW_CHARGES_VISUAL_CAP = 50 -- at least limit the quad scale.
local POW_CHARGES_ADD_CAP = 20
v.pow_charges = 0
v.powq = 0 -- quad
v.powq2 = 0 -- quad (dark layer)

local function enableEmote()
    v.canEmote = true
end

local function evilEmote()
    if v.canEmote and chance(38) then
        v.canEmote = false
        v.pushTQ(math.random(1.5, 4), enableEmote)
        if isForm(FORM_ENERGY) then
            emote(EMOTE_NAIJAEVILLAUGH)
        else
            emote(EMOTE_NAIJALAUGH)
        end
    end
end

local function happyEmote(strong)
    if v.canEmote then
        if strong then
            v.pushTQ(1.2, enableEmote)
            emote(EMOTE_NAIJASIGH)
            v.canEmote = false
        elseif chance(75) then
            v.pushTQ(math.random(1, 2.8), enableEmote)
            emote(EMOTE_NAIJAGIGGLE)
            v.canEmote = false
        end
    end
end

local function curEff()
    return v.effdata[v.eff]
end

local function updatePowCharge()
    local counted = v.pow_charges
    if counted > POW_CHARGES_VISUAL_CAP then
        counted = POW_CHARGES_VISUAL_CAP
    end
    local perc = counted / POW_CHARGES_VISUAL_CAP
    local sc = 1 + perc * 1.3
    local sc2 = 1 + perc * 1.5
    quad_scale(v.powq, sc, sc)
    quad_scale(v.powq2, sc2, sc2)
    if v.pow_charges >= 1 then
        quad_alpha(v.powq, 0.6, 1)
        quad_alpha(v.powq2, 0.6, 1)
    else
        quad_alpha(v.powq, 0, 1)
        quad_alpha(v.powq2, 0, 1)
    end
    debugLog("pow charges: " .. v.pow_charges .. ", scale: " .. sc)
end

local function increasePowCharges(amount)
    --if isForm(FORM_ENERGY) then
        v.pow_charges = v.pow_charges + amount
        if v.pow_charges > POW_CHARGES_CAP then
            v.pow_charges = POW_CHARGES_CAP
        end
        updatePowCharge()
    --end
end

-- HMM: could save it as own entity flags, but i think this is safer. Also useful if these values are needed elsewhere.
-- INDEED! inc_flagfunc.lua uses this to calculate naija's current power.
local function saveFlags()
    v.setNumFlag("Naija_ce", v.eff)
    v.setNumFlag("Naija_cetime", v.efftimer)
    v.setNumFlag("Naija_cekills", v.effrefresh)
    v.setNumFlag("Naija_ce_pow_charges", v.pow_charges)
end

local function loadFlags()
    v.eff = v.getNumFlag("Naija_ce")
    v.efftimer = v.getNumFlag("Naija_cetime")
    v.effrefresh = v.getNumFlag("Naija_cekills")
    v.pow_charges = v.getNumFlag("Naija_ce_pow_charges")
end

function v.applyEchoCE() end -- no op, not needed in this file

function v.applyPowerCE(e, maxhp)
    evilEmote()
    -- TODO: whack out some really insane shit here.
end

function v.applyCureCE(e, maxhp)
    local h = maxhp / 15
    if h > 0.7 then
        h = 0.7
    end
    
    local oldh = entity_getHealth(v.n)
    entity_heal(v.n, h)

    if oldh < entity_getHealth(v.n) then
        happyEmote(true)
    else
        happyEmote(false)
    end
    
    if chance(15) then
        cureAllStatus()
    end
end

function init(me)
	setupEntity(me)
	entity_setEntityType(me, ET_NEUTRAL) -- by making the entity neutral, normal shots won't target this
    
    entity_setTexture(me, "missingimage")
    entity_rotate(me, 360, 5, -1)
    
    if getFlag(FLAG_DBG_VISUALS) == 0 then
        entity_alpha(me, 0)
    end
    
    esetv(me, EV_LOOKAT, 0)
    esetv(me, EV_ENTITYDIED, 1)
	
	entity_setAllDamageTargets(me, false)
    entity_setUpdateCull(me, -1)
	
	entity_setCanLeaveWater(me, true)
    
    v.effdata = {}
    dofile("scripts/inc_ce_table.lua")
    
    loadSound("transturtle-light")
    
    -- power CE
    v.powq = createQuad("softglow-add")
    v.powq2 = createQuad("softglow-add", 13)
    quad_setBlendType(v.powq, BLEND_ADD)
    quad_setBlendType(v.powq2, BLEND_ADD)
    quad_color(v.powq,  0.95, 0.45, 0.08)
    quad_color(v.powq2, 0.95, 0.45, 0.08)
    quad_alpha(v.powq, 0)
    quad_alpha(v.powq2, 0)
    
end

local function deathHandler(e)
    local x, y = entity_getPosition(e)
    
    -- hackish but what should i do, the API is lacking this stuff
    entity_changeHealth(e, 1)
    local maxhp = 1 / entity_getHealthPerc(e)
    entity_changeHealth(e, -1)
    
    local ce = curEff()
    
    local incrMax = maxhp * ce.incrPerHealth
    local incr = incrMax * (ce.fadeMulti ^ v.effrefresh)
    
    --debugLog(string.format("efftimer: was %.2f, plus %.2f, now %.2f; ctr: %d; maxhp: %d", v.efftimer, incr, v.efftimer + incr, v.effrefresh, maxhp))

    
    v.effrefresh = v.effrefresh + 1
    v.efftimer = v.efftimer + incr
    
    local madIncr = ce.madnessPerKill
    if not madIncr then
        madIncr = 0
    end
    
    -- cap exaggerated pwnage and increase madness by a lot if that happens
    if ce.maxtimer and v.efftimer > ce.maxtimer then
        madIncr = madIncr * OVERPOWER_MADNESS_MULTI
        v.efftimer = ce.maxtimer
        --fade3(0, 0, 0, 0.5, 1)
        --fade3(0.5, 0.2, 0, 0.5, 1)
        spawnParticleEffect("greencrystalzap", entity_x(v.n), entity_y(v.n))
        --v.pushTQ(0.2, function()
        --    fade3(0, 0.2, 0, 0.5, 1)
        --end)
    end
    
    v.edbg(e,string.format("time: %.2f", v.efftimer), 0)
    v.edbg(e, string.format("kill: %.2f", v.effrefresh), 2)
    
    if ce.entDeathEff then
        spawnParticleEffect(ce.entDeathEff, x, y)
    end
    
    if ce.func then
        ce.func(e, maxhp)
    end
    
    if madIncr ~= 0 then
        local newmad = v.getNaijaMadness() + madIncr
        v.setNaijaMadness(newmad)
        v.edbg(e, string.format("mad: %.2f", newmad), 4)
    end
    
    -- CE power charges
    local addpow = maxhp * 0.9 -- 0.75
    if addpow > POW_CHARGES_ADD_CAP then
        addpow = POW_CHARGES_ADD_CAP
    end
    increasePowCharges(addpow)
    
    -- update flags, to preserve this across map changes
    saveFlags()
end

function entityDied(me, ent)
    if entity_getHealth(ent) > 0 and not (entity_isState(ent, STATE_DEAD) or entity_isState(ent, STATE_DEATHSCENE)) then
        --debugLog("entity deleted: " .. entity_getName(ent))
    else
        --debugLog("entity died: " .. entity_getName(ent))
        if v.isn and curEff() and v.entity_countsAsEntity(ent) then
            deathHandler(ent)
        end
    end
    entity_markDeleted(ent) -- THIS IS IMPORTANT OTHERWISE THE WHOLE MOD CRASHES DOWN
end

function postInit(me)
    v.n = getNaija()
    loadFlags()
    updatePowCharge()
end

local function updateFX(dt, x, y)
    if v.fxtimer < dt then
        local ce = curEff()
        v.fxtimer = ce.fxt
        spawnParticleEffect(ce.fx, x, y)
    else
       v.fxtimer = v.fxtimer - dt
    end
end

local function handleChangeCE()
    v.pow_charges = 0
    updatePowCharge()
end

local function applyCE(me, fe)
    debugLog("crystal effect: " .. fe)
    
    if v.eff ~= fe then
        handleChangeCE()
    end
    
    v.eff = fe
    v.effrefresh = 0
    local ce = curEff()
    v.efftimer = ce.basetime
    setFlag(FLAG_ACTIVE_CRYSTAL_POWER, CE_NONE)
    if ce.sfx then
        playSfx(ce.sfx)
    end
    
    local r, g, b = 0.6, 1, 0.8
    fade2(0, 0, 0.6, r,g,b)
    fade2(0.3, 0.3, r,g,b)
    
    setNaijaHeadTexture("blink")
    entity_animate(v.n, "energystruggle", -1)
    
    -- avoid using watch()/wait() here
      
    disableInput()
    
    v.pushTQ(0.3, function() fade2(0, 0.3, r,g,b) emote(EMOTE_NAIJAUGH) end)
    v.pushTQ(1.5, function() enableInput() setNaijaHeadTexture("") end)
    v.pushTQ(3, emote, EMOTE_NAIJAWOW)
    
end



local function shootEnergy(a, ...)
    local mx, my = getMouseWorldPos()
    local x = mx - entity_x(v.n)
    local y = my - entity_y(v.n)
    
    -- FIXME: try to mimic Avatar::getNearestTarget() instead
    local targ = v.getNearestEntityToCursor(nil, 800, ET_ENEMY, nil, v.n)
    if targ == 0 then
        targ = entity_getNearestEntity(v.n, nil, 800, ET_ENEMY, nil, v.n)
    end
    
    if targ ~= 0 and v.isDebugVis() then
        entity_doGlint(targ, "Particles/PurpleFlare")
    end
    
    if not a then -- single shot case
        local s = createShot("energyblast", v.n, targ)
        shot_setAimVector(s, x, y)
    else -- multi shot case
        local ux, uy
        for _, ang in pairs({a, ...}) do
            ux, uy = v.vector_rotateDeg(x, y, ang)
            local s = createShot("energytendril", v.n, targ)
            shot_setAimVector(s, ux, uy)
        end
    end

end

v.wasRMB = false
v.lastCharge = 0
v.shotT = 0

local function handleEnergyForm(dt)
    local rmb = isRightMouse()
    
    if rmb then
        v.lastCharge = avatar_getSpellCharge()
    end
    
    if v.shotT > 0 then
        v.shotT = v.shotT - dt
    end
    
    -- just clicked and released? assume we are shooting.
    if not rmb and v.wasRMB and v.shotT <= 0 then
        local c = v.lastCharge
        if c < 1.5 then
            v.shotT = 0.2 -- see Avatar.cpp : const float fireDelayTime = 0.2;
            -- normal shot
            if v.pow_charges >= 1 then
                increasePowCharges(-1)
                -- FIXME: save this!
                
                -- spawn an extra energy shot
                shootEnergy()
            end
        else
            -- charged shot
            if v.pow_charges >= 2.5 then
                increasePowCharges(-2.5)
                shootEnergy(-45, 0, 45)
            end
        end
    end
    
    
    v.wasRMB = rmb
end

function update(me, dt)

    v.updateTQ(dt)

    local fe = getFlag(FLAG_ACTIVE_CRYSTAL_POWER)
    if fe ~= CE_NONE then
        applyCE(me, fe)
    end
    
    local x, y = entity_getPosition(v.n)
    entity_setPosition(me, x, y)
    
    v.isn = v.isNaija()
    if not v.isn then
        -- FIXME: instead of brutal clean-up - keep the effect active, but invisible, or something
        -- it totally sucks losing it when just switching to a different char and back
        if v.efftimer > 0 then
            handleChangeCE() -- HACK: clean up
        end
        v.efftimer = 0
        v.eff = CE_NONE
    end
    
    if v.efftimer > 0 then
        updateFX(dt, x, y)
        v.efftimer = v.efftimer - dt
        if v.efftimer <= 0 then
            v.eff = CE_NONE
            handleChangeCE()
            playSfx("transturtle-light")
            v.pushTQ(2.5, emote, EMOTE_NAIJASADSIGH)
            saveFlags()
        end
    end
    
    if v.eff == CE_POWER then
        if isForm(FORM_ENERGY) then
            handleEnergyForm(dt)
        end
        -- TODO: more forms?
    end
    
    quad_setPosition(v.powq, x, y)
    quad_setPosition(v.powq2, x, y)
    
    if v.savetimer < dt then
        v.savetimer = SAVE_INTERVEL
        saveFlags()
    else
        v.savetimer = v.savetimer - dt
    end
    
    if v.ticktimer >= dt then
        v.ticktimer = v.ticktimer - dt
    else
        v.ticktimer = v.ticktimer + 0.2
        if v.eff == CE_NONE then
            setTimerTextAlpha(0, 0.7)
        else
            setTimerTextAlpha(1, 0.7)
            setTimerText(v.efftimer)
        end
    end
end

function msg(me, s, x)
end

function enterState(me)
end

function exitState(me)
end

function msg(me, msg)
end

function damage(me, attacker, bone, damageType, dmg)
	return false
end

function animationKey(me, key)
end

function hitSurface(me)
end

function songNote(me, note)
end

function songNoteDone(me, note)
end

function song(me, song)
end

function activate(me)
end

