
dofile("scripts/inc_flagfunc.lua")

v.n = 0

v.on = false
v.offt = 0
v.timer = 0
v.maxtimer = 0
v.weak = false
v.health = 0 -- we manage our own health

local SCALE = 1.3
local SCALEMAX = 1.45

function init(me)
	setupEntity(me)
	entity_setEntityType(me, ET_NEUTRAL) -- by making the entity neutral, normal shots won't target this
    
    entity_setTexture(me, "shield2ring")
    entity_setBlendType(me, BLEND_ADD)
	
	entity_setAllDamageTargets(me, false)
    entity_setUpdateCull(me, -1)
	
	entity_setCanLeaveWater(me, true)
    
    esetv(me, EV_LOOKAT, 0)
    --entity_setDeathScene(me, true)
    
    -- blocked damages
    entity_setDamageTarget(me, DT_NONE, true)
    entity_setDamageTarget(me, DT_ENEMY, true)
    entity_setDamageTarget(me, DT_ENEMY_ENERGYBLAST, true)
    entity_setDamageTarget(me, DT_ENEMY_BEAM, true)
    entity_setDamageTarget(me, DT_ENEMY_POISON, true)
    entity_setDamageTarget(me, DT_ENEMY_CREATOR, true) -- mia too?
    
    entity_rotate(me, 30, 2, -1, 1)
    entity_alpha(me, 0)
    
end

local function die(me)
    if v.on then
        entity_scale(me, 3, 3, 1)
        entity_alpha(me, 0, 1)
        v.on = false
    end
end

local function setUpAndCreate(me)
    
    if getFlag(FLAG_HAS_SHIELD2) == 0 then
        return
    end
    
    if entity_getHealthPerc(v.n) < 0.7 then
        return
    end
    
    if not v.isNaija() then
        return
    end
    
    entity_damage(v.n, me, 1)
    
    entity_scale(me, SCALE, SCALE)
    entity_scale(me, SCALEMAX, SCALEMAX, 1, -1, 1)
    entity_alpha(me, 1)
    
    local cr = entity_getCollideRadius(v.n) * 7
    entity_setCollideRadius(me, cr)
    debugLog("shield CR: " .. cr)
    
    local power = v.calcNaijaPower()
    v.maxtimer = 5 + (30 * power)
    v.timer = v.maxtimer
    local h = 5 + (12 * power)
    --entity_setHealth(me, h)
    v.health = h
    
    v.on = true
end

function postInit(me)
    v.n = getNaija()
    v.on = false
    --setUpAndCreate(me)
end

function update(me, dt)
    entity_setPosition(me, entity_getPosition(v.n)) -- FIXME: need to correct offset (more to feet a bit)
    
    if v.on then
        if isRightMouse() then
            if v.offt == 0 then
                entity_alpha(me, 0.14, 0.3) -- fade out if visible before
            end
            if isForm(FORM_NORMAL) then
                v.offt = 0.5
            else
                v.offt = 1.5
            end
        end
        
        if v.offt == 0 then
            entity_handleShotCollisions(me)
        else
            v.offt = v.offt - dt
            if v.offt <= 0 then
                entity_alpha(me, 1, 0.3) -- fade back in
                v.offt = 0
            end
        end
    
        v.timer = v.timer - dt
        if not v.weak and v.timer < 4 then
            v.weak = true
            entity_scale(me, SCALE, SCALE)
            entity_scale(me, SCALEMAX, SCALEMAX, 0.3, -1, 10)
        end
        
        if v.timer <= 0 or not v.isNaija() then
            die(me)
        end
    end
end

function enterState(me)
    if entity_getState(me) == STATE_DEATHSCENE then
        die(me)
    end
end

function exitState(me)
end

function msg(me, msg)
end

function damage(me, attacker, bone, damageType, dmg, impactx, impacty, shot)
    local n = getNaija()
    
    -- HACK: fix this or use .v.isRealEntity() or how that function was called
    if shot == 0
     or attacker == n
     or damageType == DT_ENEMY_BEAM
     or entity_isName(attacker, "ubervine") then
        return false
    end
    
    local heal = dmg / 6
    local perc = entity_getHealthPerc(me)
    --debugLog("shield dmg: " .. dmg .. ", heal: " .. heal .. ", %: " .. perc)
    
    entity_color(me, 1, perc, perc)
        
    entity_heal(n, heal)
    
    playSfx("collectmana", nil, 0.5)
    playSfx("drop")
    
    entity_color(me, 0.3, 0.3, 1, 0.1, 5, 1)
    
    v.health = v.health - dmg
    if v.health <= 0 then
        die(me)
    end
    
    return false
end

function animationKey(me, key)
end

function hitSurface(me)
end

function songNote(me, note)
end

function songNoteDone(me, note)
end

function song(me, song)
    if song == SONG_SHIELD then
        setUpAndCreate(me)
    end
end

function activate(me)
end

