
-- song manager
-- used in conjunction with the game's internal song manager

dofile("scripts/inc_flagfunc.lua")
dofile("scripts/inc_util.lua")
dofile("scripts/inc_lfa.lua")
dofile("scripts/inc_timerqueue.lua")

v.n = 0
v.singing = false

v.lfa = 0

local function testWorks()
    setSceneColor(1, 0, 0, 0.2)
    v.pushTQ(2, function() setSceneColor(1,1,1,1.5) end)
    shakeCamera(10, 1)
    setControlHint("SongMgr: It works!", false, false, false, 2)
end

local function lufiaTest()
    setControlHint("SongMgr: Lufia works!", false, false, false, 2)
end

local function onSong(song)

    -- FIXME: this should be in naija's character script
    -- leaving it here for now, for testing
    if song == SONG_ENERGYFORM then
        local rating = v.getNaijaMadnessRating()
        if rating >= MAD_MAX then
            v.pushTQ(0.7, function()
                if (isForm(FORM_ENERGY))
                or (isFlag(FLAG_HAS_SUNBEAM, 1) and isForm(FORM_SUN)) then 
                -- TODO: nature form?
                    emote(EMOTE_NAIJAEVILLAUGH)
                end
            end)
        end
    end
    
    -- call current character's onSong callback or something
end

-- mainly intended to override existing songs, so that the form hotkeys can be used by another character,
-- triggering different forms than the engine would.
local function songLFA(t, song)
    return v.lfa_create( t, function() onSong(song) end, 2)
end

function init(me)   
	setupEntity(me)
	entity_setEntityType(me, ET_NEUTRAL) -- by making the entity neutral, normal shots won't target this
    entity_setTexture(me, "missingimage")
    entity_alpha(me, 0.001)
    esetv(me, EV_LOOKAT, 0)
	entity_setAllDamageTargets(me, false)
    entity_setUpdateCull(me, -1)
	entity_setCanLeaveWater(me, true)
    
    v.lfa =
    {
        v.lfa_create( {0, 3, 6, 0, 3, 5, 0, 3, 4, 0, 2, 3}, testWorks, 2 ),
        v.lfa_create( {4,3,4,0,4,6,5,4,3,4,3,4,  4,3,4,0,4,6,7,5,3,4,5,4,3,4}, lufiaTest, 2),
        --songLFA( {7,6,5}, SONG_ENERGYFORM), -- call current
    }
end

function postInit(me)
    v.n = getNaija()
end

function update(me, dt)
    entity_setPosition(me, entity_getPosition(v.n))
    
    local singing = avatar_isSinging()
    if not singing and v.singing then
        v.singing = false
        for _, lfa in ipairs(v.lfa) do
            lfa:trigger()
            lfa:reset()
        end
    end
    v.singing = singing
    
    v.updateTQ(dt)
end

function enterState(me)
end

function exitState(me)
end

function msg(me, msg)
end

function damage(me, attacker, bone, damageType, dmg)
	return false
end

function animationKey(me, key)
end

function hitSurface(me)
end

function songNote(me, note)
end

function songNoteDone(me, note)
    for _, lfa in ipairs(v.lfa) do
        lfa:input(note)
    end
end

function song(me, song)
    onSong(song)
end

function activate(me)
end

