
dofile("scripts/inc_flags.lua")
dofile("scripts/inc_util.lua")

v.n = 0
v.emits = 0 -- { name => slot }
v.nextslot = 0

local function startEmit(me, prt)
	local slot = v.emits[prt]
	if not slot then
		slot = v.nextslot
		debugLog("visuals: init [" .. prt .. "] emitter in slot " .. slot)
		entity_initEmitter(me, slot, prt)
		entity_startEmitter(me, slot)
		v.emits[prt] = slot
		v.nextslot = slot + 1
	else
		debugLog("visuals: start [" .. prt .. "] emitter in slot " .. slot)
		entity_startEmitter(me, slot)
	end
end

local function stopEmit(me, prt)
	local slot = v.emits[prt]
	if slot then
		debugLog("visuals: stop [" .. prt .. "] emitter in slot " .. slot)
		entity_stopEmitter(me, slot)
	end
end

function init(me)
	setupEntity(me)
	entity_setEntityType(me, ET_NEUTRAL)
	entity_setTexture(me, "missingimage")
	entity_setState(me, STATE_IDLE)
    entity_scale(me, 1, 1)
    
    esetv(me, EV_LOOKAT, 0)
    entity_setAllDamageTargets(me, false)
    entity_setUpdateCull(me, -1)
    entity_setSpiritFreeze(me, false) -- keep updating
    entity_alpha(me, 0.001)

    v.emits = {}
end

function postInit(me)
    v.n = getNaija()
end

function update(me, dt)
    entity_setPosition(me, entity_x(v.n), entity_y(v.n))
end

function msg(me, s, x)
	debugLog("visuals: got msg: " .. s)
	local a = s:explode(" ", true)
	if #a >= 2 then
		if a[1] == "start" then
			startEmit(me, a[2])
		elseif a[1] == "stop" then
			stopEmit(me, a[2])
		end
	end
end

function enterState(me)
end

function exitState(me)
end

function damage(me, attacker, bone, damageType, dmg)
	return false
end

function animationKey(me, key)
end

function hitSurface(me)
end

function songNote(me, note)
end

function songNoteDone(me, note)
end

function song(me, song)
end

function activate(me)
end

function shiftWorlds(me, old, new)
end