
if not v then v = {} end
if not AQUARIA_VERSION then dofile("scripts/entities/entityinclude.lua") end

v.n = 0
v.cr = 15

v.shell = 0
v.body = 0

function init(me)

    setupEntity(me)
    entity_initSkeletal(me, "megashrimp")
	
	entity_setMaxSpeed(me, 500)
	entity_setState(me, STATE_IDLE)
	
	entity_setDeathParticleEffect(me, "TinyBlueExplode")
    entity_scale(me, 2.5)
    entity_setCollideRadius(me, v.cr)
    
    v.shell = entity_getBoneByName(me, "shell")
    v.body = entity_getBoneByName(me, "body")
end

function postInit(me)
    v.n = getNaija()
    entity_setTarget(me, v.n)
end


function update(me, dt)
	entity_handleShotCollisions(me)
	entity_touchAvatarDamage(me, v.cr, 0, 1000)
    entity_updateMovement(me, dt)

end

function hitSurface(me)
	if entity_isState(me, STATE_RETURNTOWALL) then
		entity_clampToSurface(me, 0.1)
		entity_setState(me, STATE_TRANSITION, 0.1)
	end
end

function enterState(me)
	if entity_isState(me, STATE_IDLE) then		
		--entity_animate(me, "idle", LOOP_INF)
	elseif entity_isState(me, STATE_JUMP) then
		local t = entity_getTarget(me)
		if t ~= 0 then
			entity_moveTowardsTarget(me, 1, 2000)
			local amp = 1.5
			--entity_addVel(me, entity_velx(entity_getTarget(me))*amp, entity_vely(entity_getTarget(me))*amp)
		end
		v.moveTowardsTimer = 0
		v.rotateOffset = 0
		v.flyTimer = 2
		entity_applySurfaceNormalForce(me, 800)
		--entity_adjustPositionBySurfaceNormal(me, 64)
		entity_adjustPositionBySurfaceNormal(me, v.fudge)
		
		v.vx = entity_velx(me)
		v.vy = entity_vely(me)

		--entity_animate(me, "swim", LOOP_INF)
	elseif entity_isState(me, STATE_RETURNTOWALL) then
		--entity_fireAtTarget(me, "BlasterFire", 1, 400, 200, 3)
		local s = createShot("RoodShrimp", me, entity_getTarget(me))
		shot_setOut(s, 32)
		--entity_fireShot(me, getNaija())
		debugLog("returning to wall")
	end
end

function damage(me, attacker, bone, damageType, dmg)
	if bone == v.body then
        return true
    end
    
    playNoEffect()
    return false
end

function exitState(me)
	if entity_isState(me, STATE_TRANSITION) then
		entity_setState(me, STATE_IDLE)
	end
end
