-- Copyright (C) 2007, 2010 - Bit-Blot
--
-- This file is part of Aquaria.
--
-- Aquaria is free software; you can redistribute it and/or
-- modify it under the terms of the GNU General Public License
-- as published by the Free Software Foundation; either version 2
-- of the License, or (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
--
-- See the GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

if not v then v = {} end
if not AQUARIA_VERSION then dofile("scripts/entities/entityinclude.lua") end


local MIN_SHOT_DELAY = 0.2
v.n = 0
v.head = 0
v.shottimer = 0

local function initByStanding(me)
    --if isMapName("nxtitle") then
        entity_setEntityType(me, ET_ENEMY)
        entity_setAllDamageTargets(me, true)
    --end
    
    entity_setDamageTarget(me, DT_AVATAR_SHOCK, true)
    entity_setDamageTarget(me, DT_AVATAR_ENERGYBLAST, true)
    
    --entity_setDamageTarget(me, DT_ENEMY_CREATOR, false) -- just in case
    --entity_setDamageTarget(v.n, DT_ENEMY_CREATOR, true) -- seems necessary... wtf
end

function init(me)
	setupEntity(me)
	entity_setEntityType(me, ET_NEUTRAL)
	entity_initSkeletal(me, "Mia")
	
	entity_scale(me, 0.6, 0.6)
	
	entity_setState(me, STATE_IDLE)
	
	v.head = entity_getBoneByName(me, "Head")
    
    entity_setCollideRadius(me, 40) -- FIXME
    
    entity_setAllDamageTargets(me, false)
    
    --entity_addIgnoreShotDamageType(me, DT_ENEMY_CREATOR) -- not necessary
    
    
end

function postInit(me)
	v.n = getNaija()
	entity_setTarget(me, v.n)
    initByStanding(me)
end

function update(me, dt)
	entity_setLookAtPoint(me, bone_getWorldPosition(v.head))
    entity_handleShotCollisions(me)
    --entity_doSpellAvoidance(me)
    
    if v.shottimer > 0 then
        v.shottimer = v.shottimer - dt
        if v.shottimer < 0 then
            v.shottimer = 0
        end
    end
end

function enterState(me)
	if entity_isState(me, STATE_IDLE) then
		entity_animate(me, "idle", -1)
	end
end

function exitState(me)
end

local function shoot(me, targ)
    if not targ or targ == 0 then
        targ = entity_getTarget(me)
        if targ == 0 then
            debugLog("mia: shoot: no target");
            return
        end
    end
    
    local s = createShot("miablast1", me, targ, entity_getPosition(me)) -- TODO: fire from hand
    shot_setAimVector(s, entity_getVectorToEntity(me, targ)) -- temp
end
    

function damage(me, attacker, bone, damageType, dmg)

    -- just in case (necessary for sunbeam, for example)
    if attacker == 0 then
        attacker = v.n
    end
    
    --debugLog(entity_getName(attacker) .. " - dt: ", damageType)
    
    if attacker ~= me and v.shottimer <= 0 then
        shoot(me, attacker)
        
        --entity_damage(attacker, me, dmg)
        
        v.shottimer = MIN_SHOT_DELAY
    end

    -- TODO: no effect on map nxtitle. have yet to script others.
    --playNoEffect()
    
    --if entity_isName(attacker, "ubervine") then
    --    entity_setHealth(attacker, 0)
    --end
    
	return false
end

v.recv = 0

function msg(me, s, x)
    if v.recv == "target" then
        debugLog("mia set target ent: " .. s)
        local e = entity_getNearestEntity(me, s, x)
        if e == 0 then debugLog("... not found") end
        entity_setTarget(me, e)
        v.recv = 0
    elseif s == "shoot" then
        shoot(me)
    else
        v.recv = s
    end
end

function animationKey(me, key)
end

function hitSurface(me)
end

function songNote(me, note)
end

function songNoteDone(me, note)
end

function song(me, song)
end

function activate(me)
end

