if not v then v = {} end

dofile("scripts/inc_util.lua")
dofile("scripts/inc_flags.lua")

local F_NORMAL = 0
local F_DESTROYED = 1

local EMOTE_TIMER = 1.2
local EMOTE_LAUGH_AFTER = 6

v.inited = false
v.crystal = 0
v.emotetimer = 0

function init(me)
end



local function checkModFlags(me)
    if node_isFlag(me, F_DESTROYED) then
        debugLog("node_greencrystal: was destroyed")
        if getFlag(FLAG_DBG_SPAWNALWAYS) == 0 then
            entity_msg(v.crystal, "off")
        else
            -- at least spawn an inicator that it was destroyed earlier
            v.nodeDebugVis(me, "", 2)
        end
    end
end

local function handleDestroyCrystal(me)
    
    debugLog("node_greencrystal: my crystal died")
    
    local count = getFlag(FLAG_GREENCRYSTALS_DESTROYED)
    
    if node_isFlag(me, F_NORMAL) then
        node_setFlag(me, F_DESTROYED)
        count = count + 1
        setFlag(FLAG_GREENCRYSTALS_DESTROYED, count)
    end
    
    setControlHint("Green crystals destroyed: " .. count, false, false, false, 3, "green-crystal", nil, 0.15)
    
    v.crystal = 0
    v.emotetimer = EMOTE_TIMER
end

local function handleEmote()
    local count = getFlag(FLAG_GREENCRYSTALS_DESTROYED)
    if count >= EMOTE_LAUGH_AFTER then
        emote(EMOTE_NAIJAEVILLAUGH)
    else
        emote(EMOTE_NAIJAWOW)
    end
end

function v.myInit(me)
	if v.forAllEntities(v.selectCrystal, me) then
    local extra = node_getContent(me)
        if extra == "behind" then
            entity_switchLayer(v.crystal, -2)
        end
        
        checkModFlags(me)
    else -- not found
		debugLog("node_greencrystal: no crystal found")
	end
	v.inited = true
end

function v.selectCrystal(e, me)
	if e ~= 0 and node_isEntityIn(me, e) and entity_getName(e) == "greencrystal" then
		v.crystal = e
		debugLog("node_greencrystal: found my crystal")
		return true
	end
	return false
end

function update(me, dt)
	if v.inited then
		if v.crystal ~= 0 then
			if entity_isState(v.crystal, STATE_DEATHSCENE) then
				handleDestroyCrystal(me)
			end
		else
            if v.emotetimer > 0 then
                v.emotetimer = v.emotetimer - dt
                if v.emotetimer <= 0 then
                    handleEmote()
                end
            end
        end
	else
		v.myInit(me)
	end
end

function activate(me)
end

function songNote(me, note)
end

function songNoteDone(me, note, done)
end
