if not v then v = {} end

dofile("scripts/inc_flags.lua")

v.dmg = 0.1
v.timer = 1
v.t = 0
v.snd = 1
v.inside = false
v.normaltimer = 0
v.lowtimer = 0

function init(me)
    local c = node_getContent(me)
    local t = node_getAmount(me)
    
    if c and c ~= "" then
        v.dmg = tonumber(c)
    end
    
    if t > 0 then
        v.timer = t
    end
    v.t = t
end

local function getDmgPerSec()
    return v.dmg / v.timer
end
local function getSecsLeft(e)
    return entity_getHealth(e) / getDmgPerSec()
end

function v.doHeatDamage(e)

    -- not using entity_damage here() intentionally, to overcome Naija's damage multiplier in various forms,
    -- and to be sure the damage immmunity timer does not kick in.
    if not v.isDebug() then
        if entity_getHealth(e) < v.dmg then
            debugLog("heat death!")
            entity_setHealth(e, 0)
            entity_heal(e, 0) -- HACK: force display damage overlay
        else
            debugLog("heat damage: " .. v.dmg)
            entity_changeHealth(e, -v.dmg)
        end
   
        -- sound spam is annoying while debugging, so we turn this off
        if chance(28) then
            entity_playSfx(e, "hit" .. v.snd)
            v.snd = v.snd + 1
            if v.snd > 8 then
                v.snd = 1
            end
        end
        entity_playSfx(e, "pain")
    end
    

    local dps = getDmgPerSec();
    
    debugLog("dps: " .. dps)
    
    if dps >= 0.5 then
        if chance(38) then
            entity_playSfx(e, "boil")
        end
        
        if dps >= 1 then
            spawnParticleEffect("heathit", entity_getPosition(e))
        end   
    end
    
    local x = 0.7 - (v.dmg * 0.7) -- blargh
    if x < 0 then
        x = 0
    end
    
    entity_color(e, 1, 1, 1) -- revert
    entity_color(e, 1, x, x, 0.1, 9, 1) -- damage flash
    v.normaltimer = 3
    
    if v.lowtimer <= 0 and getSecsLeft(e) <= 5 then
        v.lowtimer = 15
        --emote(EMOTE_NAIJALOW) -- never plays naijalow4, bah
        entity_playSfx(e, "naijalow4")
    end
        
end

function update(me, dt)
    local h = getFlag(FLAG_NO_HEAT_DAMAGE) == 0
    if v.t < dt then
        local n = getNaija()
        local isIn = node_isEntityIn(me, n)
        if h then
            if isIn then
                -- HACK: when travelling between nodes, prevent voice spam
                if not v.inside and getSecsLeft(n) <= 5 then
                    v.lowtimer = 15
                end
                v.doHeatDamage(n)
            end
        end
        v.t = v.timer
        v.inside = isIn
    else
        v.t = v.t - dt
    end
    
    if h and v.inside then
        setNaijaHeadTexture("pain", v.timer) -- FIXME: this is deprecated
    end
    
    -- HACK: have seen reverting color not working properly when leaving and entring 2 neighbor hot areas
    if v.normaltimer > 0 then
        v.normaltimer = v.normaltimer - dt
        if v.normaltimer <= 0 then
            entity_color(getNaija(), 1, 1, 1, 3) -- over 3 secs
        end
    end
    
    if v.lowtimer > 0 then
        v.lowtimer = v.lowtimer - dt
    end
    
end

function activate(me)
end

function songNote(me, note)
end

function songNoteDone(me, note, done)
end
