-- used on map volcano02

-- TODO: use a flag to turn them off, or something

if not v then v = {} end

local T_GENERIC = 0 -- always on
local T_A = 1       -- A type, on when B is not on
local T_B = 2       -- B type, on when A is not on


local FIZZ_STEP_MIN = 40
local FIZZ_STEP_MAX = 50

local CULLDIST = 1300 -- for updating (that many particles are a resource hog!)

v.t = 0
v.sel = false
v.type = T_GENERIC
v.ctrl = 0
v.on = true
v.shocktimer = 0

function init(me)
    loadSound("powerline")
    local c = node_getContent(me)
    if c == "a" then
        v.type = T_A
    elseif c == "b" then
        v.type = T_B
    end
    v.ctrl = node_getNearestNode(me, "crystalchargespecial")
end

local function fizzh(me, sel) -- only horizontal for now

    local w, h = node_getSize(me)
    local cx, cy = node_getPosition(me)
    local n = getNaija()
    local dx = math.abs(cx - entity_x(n))
    local dy = math.abs(cy - entity_y(n))
    local d = (dx + dy) * 0.5 -- rough guess
    
    -- do not spawn when too far away (save CPU)
    if d > CULLDIST then
        return
    end
    
    local halfx = w * 0.5
    local x = cx - halfx
    local xend = cx + halfx
    
    while x < xend do
        spawnParticleEffect("jellyzapfx", x, cy)
        if chance(30) then
            spawnParticleEffect("powerlines", x, cy)
        end
        x = x + math.random(FIZZ_STEP_MIN, FIZZ_STEP_MAX)
    end
    
    playSfx("shield-hit", 0.7, 0.33, 0, node_x(me), node_y(me))
end

local function tryDealDamage(me, n)
    if node_isEntityIn(me, n) then
    	entity_clearVel(n)
        local w, h = node_getSize(me)
		local x, y = 0, 0
		if w > h then
			y = entity_y(n) - node_y(me)
            x = (math.random() - 0.5) * (y/2)
			if entity_y(n) < node_y(me) then
				entity_setPosition(n, entity_x(n), node_y(me) - (h/2) - 10)
			else
				entity_setPosition(n, entity_x(n), node_y(me) + (h+10)/2 + 10)
			end
		else
			x = entity_x(n) - node_x(me)
            y = (math.random() - 0.5) * (x/2)
		end
        
        x, y = vector_setLength(x, y, 12000)
		entity_setMaxSpeedLerp(n, 4)
		entity_setMaxSpeedLerp(n, 1, 4)
		entity_addVel(n, x, y)

		emote(EMOTE_NAIJAUGH)
        entity_damage(n, n, 2)
        
        shakeCamera(20, 0.5)
        setGameSpeed(0.3)
        setGameSpeed(1, 1)
        
        playSfx("shield-hit", 0, 1.8)
		spawnParticleEffect("barrier-hit", entity_x(n), entity_y(n))
		spawnParticleEffect("jellyzapprezap", entity_x(n), entity_y(n))
        return true
    end
    return false
end

function update(me, dt)
    if v.t < dt then
        local state = v.ctrl ~= 0 and node_isFlag(v.ctrl, 0)
        
        v.t = 0.2 + (math.random() * 0.5)
        
        if not state then
            v.t = v.t * 3
        end
        
        if (v.type == T_GENERIC)
        or (v.type == T_A and state)
        or (v.type == T_B and not state) then
            fizzh(me, v.sel)
            v.sel = not v.sel
            v.on = true
        else
            v.on = false
        end
    else
        v.t = v.t - dt
    end
    
    if v.shocktimer > 0 then
        v.shocktimer = v.shocktimer - dt
    elseif v.on then
        if tryDealDamage(me, getNaija()) then
            v.shocktimer = 0.3
        end
    end
end

function songNote(me, note)
end

function songNoteDone(me, note, done)
end
