-- changed version of the original node_sleep.lua,
-- that works mostly without watch() or wait()
-- (necessary to successfuly break sleep from scripts, and accept damage without nested main hackery)

dofile("scripts/inc_timerqueue.lua")

v.doSleep = false

function init(me)
	node_setCursorActivation(me, true)
end
	
--[[local function visions(me)
	if isFlag(FLAG_VISION_ENERGYTEMPLE, 1) and isFlag(FLAG_ENERGYBOSSDEAD, 0) then
		vision("EnergyTemple", 3)
		playSfx("VisionWakeup")
		return true
	end
	return false
end]]

local function prepareSleep(me, heal)
    debugLog("prepare sleep")
    local n = getNaija()
    avatar_fallOffWall()
	entity_idle(n)
	
	if getForm() ~= FORM_NORMAL then
		watch(0.5)
		changeForm(FORM_NORMAL)
		watch(0.5)
	end
	
	local li = 0
	if hasLi() then
		li = getLi()
		--entity_setState(li, STATE_IDLE, -1, 1)
		entity_setState(li, STATE_PUPPET, -1, 1)
		entity_flipToEntity(li, n)
	end
	
	if li ~= 0 then
		fade2(1, 0.5, 1, 1, 1)
		watch(0.5)
		
		entity_setState(li, STATE_PUPPET)
		
		entity_setPosition(li, entity_x(n), entity_y(n))
		
		fade2(0, 0.5, 1, 1, 1)
	end

	
	entity_rotate(n, 0, 0.1)
	esetv(n, EV_LOOKAT, 0)
	entity_swimToNode(n, me)
	entity_watchForPath(n)
    disableInput()
	
	entity_setPosition(n, node_x(me), node_y(me), 0.1)
	
	entity_idle(n)
	
	if li ~= 0 then
		entity_clearVel(li)
		entity_setPosition(li, node_x(me), node_y(me)-10, 1)
	end

	setSceneColor(0.5, 0.5, 1, 3)
	entity_animate(n, "sleep", LOOP_INF, nil, 0.5)
	overrideZoom(1.25, 2)
	--watch(1)
    
    v.pushTQ(1, function()
	
        if li ~= 0 then
            entity_offset(li, 0, 0)
            entity_setInternalOffset(li, 0, 0)
            entity_clearVel(li)
            entity_setPosition(li, node_x(me), node_y(me),0.1)
            entity_animate(li, "sleep", LOOP_INF, nil, 0.5)
        end
        
        emote(EMOTE_NAIJASADSIGH)
        fadeOutMusic(1)
        fadeOut(1)
        
        v.pushTQ(1, function()
            if heal then
                entity_heal(n, 999)
                cureAllStatus()
                --entity_setState(n, STATE_SLEEP) -- not yet. when screen fades back in.
            end
            
            v.pushTQ(2, function()
	
                fadeIn(1)
                
                v.pushTQ(1, function()
                    debugLog("really sleep now")
                    v.doSleep = true
                end)
            end)
        end)
    end)
    
end

local function wakeup(me)
    debugLog("wakeup!")
    local n = getNaija()
    local li = getLi()
    v.doSleep = false

    setSceneColor(1, 1, 1, 3)
	entity_idle(n)
	
	overrideZoom(1, 1)
	--musicVolume(1, 1)
	
	
	updateMusic()
	
	--esetv(n, EV_NOINPUTNOVEL, 0)
    entity_setState(n, STATE_IDLE)
    
	if hasLi() then
		entity_setState(getLi(), STATE_IDLE)
	end
    
    enableInput()
    entity_addVel(n, 0, -200)
    
	v.pushTQ(1, function()
        --esetv(n, EV_NOINPUTNOVEL, 1)
        overrideZoom(0)	
        esetv(n, EV_LOOKAT, 1)
        --enableInput() -- done earlier
        avatar_fallOffWall() -- WTF HACK
    end)
end


local function sleep(me)
    if isFlag(FLAG_BREAK_SLEEP, 2) then
        return
    end
    
    local n = getNaija()
    
    local dmg = entity_getHealthPerc(n) < 0.99 -- grace value
    
    if isLeftMouse() or isRightMouse()
     or (not isInCutscene() and isEscapeKey())
     or isFlag(FLAG_BREAK_SLEEP, 1)
     or dmg then 
        wakeup()
        if dmg then
            emote(EMOTE_NAIJAUGH)
        end
    else
        disableInput() -- just in case
        entity_setState(n, STATE_SLEEP)
    end
end

-- hackish: if entity passed, do not heal
-- means: if rightclicking, always heal
function activate(me, ent)
	local n = getNaija()
	
	prepareSleep(me, not ent or ent == 0)

end

function update(me, dt)
    v.updateTQ(dt)
    if v.doSleep then
        sleep(me)
    end
end
