
-- manages waterlevel and warp arrival animation

local MIN_WATERLEVEL = 1750
local OFFSET = 55

dofile("scripts/inc_timerqueue.lua")

v.needinit = true
v.cut = false -- cutscene done?


local function doScene(me)
    if v.cut then return end
    
    -- hangs if using watch() here... ?!
    
    v.cut = true
    disableInput()
    local n = getNaija()
    entity_alpha(n, 0)
    wait(1)
    
    playSfx("spirit-awaken")
    spawnParticleEffect("priestexplode", entity_getPosition(n))
    wait(0.5)
    
    entity_alpha(n, 1, 1.2)
    
    
    entity_animate(n, "agony")
    while entity_isAnimating(n) do
        wait(FRAME_TIME)
    end
    enableInput()
    node_setFlag(me, 1)
    debugLog("startdreamspecial warp in done")
end


function init(me)
    loadSound("spirit-awaken")
    v.pushTQ(0.5, doScene, me)
    v.cut = node_isFlag(me, 1)
end

function update(me, dt)
    if v.needinit then
        v.needinit = false
        if not v.cut then
            entity_alpha(getNaija(), 0) -- prepare cutscene, just in case
        end
        setCanChangeForm(true)
        setCostume("")
        setCanChangeForm(false)
    end
    
    v.updateTQ(dt)
        
    local _, y = entity_getPosition(getNaija())
    local wl = y + OFFSET
    
    if wl > MIN_WATERLEVEL then
        setWaterLevel(wl)
    else
        setWaterLevel(MIN_WATERLEVEL)
    end
end

function activate(me)
end

function songNote(me, note)
end

function songNoteDone(me, note, done)
end
