
if not v then v = {} end

dofile("scripts/inc_util.lua")
dofile("scripts/inc_flags.lua")
dofile("scripts/inc_transdata.lua")

local STATE_DISABLED = 1000 -- must match the value in greencrystal.lua

v.hasn = false
v.needinit = true
v.crystal = 0

function init(me)
	node_setCursorActivation(me, true)
    loadSound("mia-appear")
    loadSound("mia-scream")
end

local function zapScene(n)
    debugLog("activate trap save point!")
    
    -- go there
    disableInput()
    overrideZoom(1.55, 2)
    entity_animate(n, "touchcrystal")
    watch(2.4)
    
    -- first zap, for short time
    local x, y = entity_getPosition(n)
    playSfx("fizzlebarrier")
    watch(0.2)
    setNaijaHeadTexture("shock")
    playSfx("naijaugh3")
    entity_animate(n, "shockedbycrystal", -1)
    local i = 15
    while i > 0 do
        spawnParticleEffect("jellyzapfx", x + math.random(-50, 50), y + math.random(-60, 60))
        i = i - 1
        watch(0.1)
        if i == 8 then
            playSfx("naijalow2")
        end
    end
    
    -- final zap
    --setGameSpeed(0.8, 2)
    spawnParticleEffect("jellyshock", x, y)
    playSfx("naijazapped")
    setNaijaHeadTexture("pain", 2.5)
    watch(0.5)
    entity_animate(n, "dead")
    fadeOut(4)
    watch(5)
    

    -- HACK: this is just for teaser... for now
    --v.doTransitionTo("naijamiajailout")
    -- no! better this below.
        
    -- FIXME: might want to do something else here?
    -- Question is, erase memory, or not.
    -- If so, teleport to lower cave, and let the scene there run as usual?
    setStringFlag("TEMP_trapsavepoint", "1") -- for cutscene_miatrapsnaija.lua
    loadMap("nxtitle")
end

local function outScene(n)
    debugLog("outScene")
    v.recolorCrystal(false)
    playSfx("mia-appear")
    watch(2)
    playSfx("mia-scream")
    entity_alpha(n, 0)
    watch(5)
    overrideZoom(0.7, 6)
    fadeIn(2)
    watch(3)
    fadeOut(3)
    watch(4)
end

local function resetToNormal(n)
    --setGameSpeed(1)
    entity_alpha(n, 1)
    fadeIn(1)
    enableInput()
    disableOverrideZoom()
    setNaijaHeadTexture("")
    --playMusic("veil")
end

local function trySave(p, n)
    overrideZoom(1.15, 1)
    spawnParticleEffect("saveglow", node_x(p), node_y(p))
    playSfx("memorycrystalactivate")
    entity_animate(n, "save")
    watch(1.2)
    fadeOutMusic(3)
    spawnParticleEffect("lancehit", node_x(p), node_y(p))
    watch(0.2)
    spawnParticleEffect("lancehit", node_x(p) + 80, node_y(p) + 60)
    watch(1.8)
end

function v.recolorCrystal(red)
    local tex
    if red then
       tex = "save-crystal-0001"
    else
        tex = "green-crystal2"
    end
    debugLog("trapsavepoint: set tex " .. tex)
    entity_setActivationType(v.crystal, AT_NONE) -- so that always node_trapsavepoint can trigger
    entity_setTexture(v.crystal, tex)
    entity_scale(v.crystal, 1.05, 1.05)
end

function v.isCrystal(e)
	return e ~= 0 and entity_getName(e) == "greencrystal"
end

function activate(me)
    v.hasn = false
	local n = getNaija()
    entity_flipToNode(n, me)
    entity_moveToNode(n, me, 5)
    entity_animate(n, "pushforward")
    entity_rotate(n, 0, 1)
    while not v.hasn do
        watch(0.2)
    end
    trySave(me, n)
    zapScene(n)
    outScene(n)
    resetToNormal(n)
    -- TODO: port to other map/li/etc
end

function update(me, dt)
    if not v.hasn then
        if node_isEntityIn(me, getNaija()) then
            v.hasn = true
        end
    end
    
    if v.needinit then
        v.needinit = false
        v.crystal = node_getNearestEntity(me, "greencrystal")
        if v.crystal ~= 0 then
            v.recolorCrystal(true)
        else
            debugLog("trapsavepoint: no crystal nearby")
            node_setCursorActivation(me, false)
        end
    end
    
    if v.crystal ~= 0 and (entity_isState(v.crystal, STATE_DISABLED) or entity_isState(v.crystal, STATE_DEATHSCENE)) then
        debugLog("trapsavepoint: nearby crystal is disabled or dead")
        node_setCursorActivation(me, false)
        v.crystal = 0
    end
end
