
-- alternative zoom node for cutscenes.
-- the game overrides the zoom whenever we are in a "normal" zoom node,
-- this one just does it upon entering or exiting.
-- note: this one does not zoom as soft as the original!

if not v then v = {} end

v.wasIn = false
v.zoom = 0
v.t = 0

local function startZoom()
    overrideZoom(v.zoom, v.t)
end

local function resetZoom()
    overrideZoom(0)
end

function init(me)
    v.zoom = tonumber(node_getContent(me)) or 0
    v.t = node_getAmount(me)
    if v.zoom <= 0 then
        debugLog("node_zoom2: WARNING: zoom <= 0")
    end
end

function update(me, dt)
    if v.zoom > 0 then
        local inside = node_isEntityIn(me, getNaija())
        if inside and not v.wasIn then
            startZoom()
        elseif not inside and v.wasIn then
            resetZoom()
        end
        v.wasIn = inside
    end
end

function songNote(me, note)
end

function songNoteDone(me, note, done)
end
