-- Copyright (C) 2007, 2010 - Bit-Blot
--
-- This file is part of Aquaria.
--
-- Aquaria is free software; you can redistribute it and/or
-- modify it under the terms of the GNU General Public License
-- as published by the Free Software Foundation; either version 2
-- of the License, or (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
--
-- See the GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

if not v then v = {} end
if not AQUARIA_VERSION then dofile("scripts/entities/entityinclude.lua") end

dofile("scripts/inc_flags.lua")

v.n = 0
function v.commonInit(me, gfx, r)
	-- note: if you want to add different weight to each rock, then
	-- send it through here
	if r == 0 then
		r = 80
	end
	setupEntity(me, gfx, -2) -- below terrain
	entity_setCollideRadius(me, r)
	entity_setFillGrid(me, true)
	
	esetv(me, EV_TYPEID, EVT_ROCK)
	esetv(me, EV_LOOKAT, 0)
	
	entity_setHealth(me, 15) -- FIXME
	
	entity_setUpdateCull(me, 3000) -- not sure!
    
    entity_setAllDamageTargets(me, false)
    entity_setDamageTarget(me, DT_ENEMY_MANTISBOMB, true)
    
    entity_setDamageTarget(me, DT_AVATAR_BITE, false)
end

function postInit(me)
	v.n = getNaija()
	reconstructEntityGrid()
    
    if entity_isFlag(me, 1) then -- destroyed?
        v.entDebugVis(me, "", 1.3)
        if getFlag(FLAG_DBG_SPAWNALWAYS) == 0 then
            v.death(me, true)
        end
    end
        
end

function v.commonUpdate(me, dt)
	--entity_setVelLen(me, 0) -- HACK
	--entity_updateMovement(me, dt)
	
	--if entity_touchAvatarDamage(me, entity_getCollideRadius(me), 0) then
	--	if avatar_isBursting() and entity_setBoneLock(v.n, me) then -- FIXME: invalid entity ptr
			-- yay!
	--	end
	--end
	
	entity_handleShotCollisions(me)
end

function v.death(me, silent)
	entity_setFillGrid(me, false)
	reconstructEntityGrid()
    
	-- from breakablecommon.lua
	--spawnParticleEffect("SmallBubbleExplosion", entity_getPosition(me)) -- FIXME
    --playSfx(v.breakSound, 0, v.sfxVol) -- FIXME
    
    if not silent then
        for i=1,3 do
            local e = createEntity("BrokenPiece", "", entity_x(me), entity_y(me))
            entity_setTexture(e, "bombrock-part")
        end
        entity_setFlag(me, 1)
    end
	entity_alpha(me, 0, 0.1)

    entity_delete(me)
end

function damage(me, attacker, bone, damageType, dmg)
	return damageType == DT_ENEMY_MANTISBOMB
end

function enterState(me)
end

function exitState(me)
end

function hitSurface(me)
end

function activate(me)
end

function msg(me, s, x)
    debugLog("bombrock: msg: " .. s)
    if s == "expl" then
        v.death(me)
    end
end
